////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
////  * Radio FM avec prise en charge du RDS                                ////
////  * Sortie sur un afficheur TFT couleur 320 x 240                       ////
////                                                                        ////
////     (C) D6t'M - Thierry ABRARD-PARIZET - Dcembre 2014                 ////
////     Email : contact@d6tm.fr                                            ////
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
////  * Microchip PIC 32MX460F512L                                          ////
//// ====================================================================== ////
////////////////////////////////////////////////////////////////////////////////

////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
#include "SF_driver.c"
#include "6RFM_objects.h"
#include "6RFM_driver.c"
#include "6RFM_polices.h"
#include "TFT_couleurs.h"
#include "6RFM_images.c"
#include "6RFM_logo.c"
#include "6RFM_chiffres.c"
#include "6RFM_mem.c"
#include "6RFM_TFT.c"
#include "RTCC.c"
#include "6RFM_accel.c"
#include "6RFM_si4703.c"


////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
void Timer1Interrupt() iv IVT_TIMER_1 ilevel 7 ics ICS_SRS
{
  T1IF_bit         = 0;
  tempo_500++;
  if (tempo_500 == 10)
  {

     tempo_sec++;
     tempo_500 = 0;
     if (flag_sec == 0)
     {
        flag_sec = 1;
     }
     else
     {
        flag_sec = 0;
     }
     if ((flag_mute == 1) && (flag_pwr == 1))
     {
        if (flag_bascule == 0)
        {
           flag_bascule = 1;
           TFT_image(0,120,Vol_MUTE_FOCUS,1);
        }
        else
        {
           flag_bascule = 0;
           TFT_image(0,120,Vol_MUTE_ON,1);
        }
     }
  }
}
////////////////////////////////////////////////////////////////////////////////
////                       Programme principal                              ////
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
void main()
{
   unsigned short  i,j;
   
   char            out[65];
   char            txt[10];
   char            nom[9];
   char            texte[9];
   unsigned        test_y;
   
   heudat          hrds;
   heudat          hpic;
   short           date_change;

   unsigned int    tft_x,tft2_x;
   unsigned int    tft_y,tft2_y;
   
   unsigned        x_freq;
   unsigned        y_freq;
   unsigned        x_nom;
   unsigned        y_nom;
   unsigned        x_texte;
   unsigned        y_texte;
   unsigned        freq_tempo;
   
   char            d_jour[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
   ch_txt_17       jour[7];
   ch_txt_17       mois[13];

   char            TFT_refresh;
   unsigned short  mem_refresh;

   rds             drds;
   chaine_mat      rtrds;
   
   unsigned short  heure_auto;
   unsigned short  jeu_mem;
   unsigned short  mem_active;
   
   memoire         mem[8];

   
/*----------------------------------------------------------------------------*/
   Stereo_ShutDown(OFF);
   Mono_ShutDown(OFF);
   Init_MCU();
   Init_PMP();
   Init_TP();
   Init_RTCC();
/*----------------------------------------------------------------------------*/
   TFT_Set_Pen(CL_Black, 1);
   TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_YELLOW, FO_HORIZONTAL);
   TFT_BackLight(OFF);
   TFT_Fill_Screen(COUL_FOND);
 //  TFT_BackLight(ON);
 //  Calib_TP();
 //  TFT_BackLight(OFF);
   TFT_Write_Text("6RFM Ver 1.5b", 185,220);
   TFT_image(120,180,Logo_FM,1);
   TFT_FadeIn(1000);
   TFT_Set_Font(&Verdana12x13_Regular, LIGHTGREEN, FO_HORIZONTAL);
   TFT_Write_Text("Chargement des ressources...", 10, 20);
/*----------------------------------------------------------------------------*/
   I2C2_Init(250000);
   I2C1_Init(100000);
   delay_ms(100);
   ACCEL_Start();
   Si4703_Start();
   InitTimer1();
   Si4703_Sleep();

   sf_start();
     
/*----------------------------------------------------------------------------*/
   digit_heure[0] = &chiffre_0;
   digit_heure[1] = &chiffre_1;
   digit_heure[2] = &chiffre_2;
   digit_heure[3] = &chiffre_3;
   digit_heure[4] = &chiffre_4;
   digit_heure[5] = &chiffre_5;
   digit_heure[6] = &chiffre_6;
   digit_heure[7] = &chiffre_7;
   digit_heure[8] = &chiffre_8;
   digit_heure[9] = &chiffre_9;
   digit_heure[10] = &chiffre_2p_ON;
   digit_heure[11] = &chiffre_2p_OFF;
/*----------------------------------------------------------------------------*/
   strcpy(jour[0],"Dim");
   strcpy(jour[1],"Lun");
   strcpy(jour[2],"Mar");
   strcpy(jour[3],"Mer");
   strcpy(jour[4],"Jeu");
   strcpy(jour[5],"Ven");
   strcpy(jour[6],"Sam");

   strcpy(mois[0],"");
   strcpy(mois[1],"jan");
   strcpy(mois[2],"fev");
   strcpy(mois[3],"mar");
   strcpy(mois[4],"avr");
   strcpy(mois[5],"mai");
   strcpy(mois[6],"jun");
   strcpy(mois[7],"jui");
   strcpy(mois[8],"aou");
   strcpy(mois[9],"sep");
   strcpy(mois[10],"oct");
   strcpy(mois[11],"nov");
   strcpy(mois[12],"dec");
/*----------------------------------------------------------------------------*/

   hpic.hh        = 0;
   hpic.mm        = 0;
   hpic.ss        = 0;
   hpic.jj        = 0;
   hpic.dd        = 1;
   hpic.mo        = 1;
   hpic.yy        = 12;
   TFT_refresh    = 1;
   flag_pwr       = 0;
   flag_mute      = 0;
   flag_bascule   = 0;
   flag_stereo    = 0;
   flag_rds       = 0;
   flag_logo_rds  = 0;
   flag_frequence = 1;
   mem_refresh    = 1;

   tempo_500      = 0;
   tempo_sec      = 0;
   x_freq         = 69;
   y_freq         = 26;
   x_nom          = 177;
   y_nom          = 26;
   x_texte        = 69;
   y_texte        = 59;
   scroll         = 0;
   max_scroll     = 0;
   
   memset(drds.ps,' ',8);
   memset(drds.rt,' ',64);
   drds.rt[64]    = '\0';
   memset(rtrds.bit_chaine,0,384);
   rtrds.x        = x_texte;
   rtrds.y        = y_texte;
   rtrds.delta    = scroll;
   rtrds.c_t      = 0x0000;
   rtrds.c_c      = 0x00EA;
   rtrds.f_t      = 0x0000;
   rtrds.f_c      = 0xBEBD;
   rtrds.taille   = 0;
   rtrds.largeur  = 83;
   drds.heure_ok  = 0;
   sensibilite    = 0;
/*----------------------------------------------------------------------------*/
   while(TP_TFT_Press_Detect())
   {
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
          if (TFT_y > 100)
          {
             TFT_Write_Text("initialisation des ressources...", 10, 60);
             Write_RTCC_HHMMSS(hpic.hh,hpic.mm,hpic.ss);
             Write_RTCC_YYMMDDJS(hpic.jj,hpic.dd,hpic.mo,hpic.yy);
          }
/*----------------------------------------------------------------------------*/
          if ((tft_x > 200) && (tft_y < 40))
          {
            TFT_Write_Text("effacement des valeurs et initialisation des ressources...", 10, 60);
            Write_RTCC_HHMMSS(hpic.hh,hpic.mm,hpic.ss);
            Write_RTCC_YYMMDDJS(hpic.jj,hpic.dd,hpic.mo,hpic.yy);
            heure_auto     = 0; // 0 = manuel / 1 = auto RDS
            hpic.fuseau    = 2; // France = GMT + 2;
            hpic.ete_hiver = 1; // 0 = ete / 1 = hiver
            volume         = 0;
            frequence      = 875;
            jeu_mem        = 0;
            mem_active     = 10;
            for (i = 0 ; i < T_EEPROM ; i++)
            {
               eprom_0[i] = 0;
               eprom_1[i] = 0;
            }
            for (i = 0 ; i < AD_NOM_1 ; i++)
            {
               eprom_2[i] = 0;
            }
            for (i = AD_NOM_1 ; i < T_NOM ; i++)
            {
               eprom_2[i] = 0x20;
            }
            eprom_0[AD_FUSEAU]    = (short)hpic.fuseau;
            eprom_0[AD_ETE]       = (short)hpic.ete_hiver;
            eprom_0[AD_H_AUTO]    = (unsigned short)heure_auto;
            eprom_0[AD_JEU_MEM]   = (unsigned short)jeu_mem;
            eprom_0[AD_MEM_ACT]   = (unsigned short)mem_active;
            eprom_0[AD_VOLUME]    = (unsigned short)volume;

            eprom_1[AD_FREQUENCE] = (unsigned)frequence;
            SerialFlash_SectorErase(SEC_0);
            SerialFlash_SectorErase(SEC_1);
            SerialFlash_SectorErase(SEC_2);
            SerialFlash_WriteArray(SEC_0,&eprom_0,T_EEPROM);
            SerialFlash_WriteArray(SEC_1,&eprom_1,T_EEPROM * 2);
            SerialFlash_WriteArray(SEC_2,&eprom_2,T_NOM);
         }
      }
   }
/*----------------------------------------------------------------------------*/

   SerialFlash_ReadArray(SEC_0,&eprom_0,T_EEPROM);
   SerialFlash_ReadArray(SEC_1,&eprom_1,T_EEPROM * 2);
   SerialFlash_ReadArray(SEC_2,&eprom_2,T_NOM);
   
   hpic.fuseau    = (short)eprom_0[AD_FUSEAU];//2; // France = GMT + 2;
   hpic.ete_hiver = (short)eprom_0[AD_ETE];//1; // 0 = ete / 1 = hiver
   volume         = (unsigned short)eprom_0[AD_VOLUME];
   frequence      = (unsigned)eprom_1[AD_FREQUENCE];
   heure_auto     = (unsigned short)eprom_0[AD_H_AUTO];
   jeu_mem        = (unsigned short)eprom_0[AD_JEU_MEM];
   mem_active     = (unsigned short)eprom_0[AD_MEM_ACT];
   
   for (i=0 ; i < 8 ; i++)
   {
      if (i == mem_active) mem[i].etat = 1;
      else  mem[i].etat = 0;
      mem[i].freq     =  (unsigned)eprom_1[AD_MEM_0 + i];
      mem[i].y        =  136;
      if (i < 4)
      {
         mem[i].x        =  88 + (63 * i);
         mem[i+4].x      =  88 + (63 * i);
      }
      for (j = 0 ; j < 8 ; j++)
      {
         nom[j] = eprom_2[AD_NOM_1 + (16 * i) + j];
      }
      nom[8] = '\0';
      strcpy(mem[i].nom,nom);
      mem[i].nom_ok = eprom_2[AD_NOM_OK + i];
   }
   mem[0].img_on   = &b1_on;
   mem[0].img_off  = &b1_off;
   mem[1].img_on   = &b2_on;
   mem[1].img_off  = &b2_off;
   mem[2].img_on   = &b3_on;
   mem[2].img_off  = &b3_off;
   mem[3].img_on   = &b4_on;
   mem[3].img_off  = &b4_off;
   mem[4].img_on   = &b5_on;
   mem[4].img_off  = &b5_off;
   mem[5].img_on   = &b6_on;
   mem[5].img_off  = &b6_off;
   mem[6].img_on   = &b7_on;
   mem[6].img_off  = &b7_off;
   mem[7].img_on   = &b8_on;
   mem[7].img_off  = &b8_off;
/*----------------------------------------------------------------------------*/
   heure_pic(&hpic);
   date_heure(&hpic,&d_jour);
   heure_ete_hiver(&hpic);
   hpic.hh -= hpic.ete_hiver;
   jour_sem(&hpic);
   hpic.change    = 1;
/*----------------------------------------------------------------------------*/
   TFT_Write_Text("Fin du chargement des ressources...", 10, 70);
   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
   TFT_FadeOut(1000);
   TFT_Fill_Screen(COUL_FOND);
   aff_tuner_Off();
   TFT_FadeIn(1000);
   
   EnableInterrupts();
   T1IE_bit = 1;             // Enable Timer1 Interrupt
   ON__T1CON_bit = 1;        // Enable Timer1

   while (1)
   {
      date_change = heure_pic(&hpic);
      if (flag_pwr == 0)
      {
         aff_heure_ecran_off(78,16,&hpic,flag_sec);
         if ((date_change) || (TFT_refresh))
         {
            aff_date_ecran_off(74,84,&hpic,&jour,&mois);
            TFT_refresh = 0;
         }
      }
      else
      {
         aff_heure_ecran_on(252,2,&hpic,flag_sec);
         if (flag_frequence)
         {
            aff_frequence(x_freq,y_freq,frequence);
            flag_frequence = 0;
         }
         flag_stereo = Si4703_IsStereo();
         flag_logo_rds = Si4703_IsRDS();
         flag_rds    = Si4703_RDSRdy(&drds);
         puissance = Si4703_GetRSSI();
         if ((mem_active < 8) && (flag_rds != 1) && (mem[mem_active].etat == 1) && (mem[mem_active].nom_ok == 0))
         {
            freq_tempo = frequence;
            nom[0] = ' ';
            nom[1] = ' ';
            if (freq_tempo < 1000) nom[2] = ' ';
            else nom[2] = '0' + (freq_tempo / 1000);
            freq_tempo %= 1000;
            nom[3] = '0' + (freq_tempo /  100);
            freq_tempo %= 100;
            nom[4] = '0' + (freq_tempo /   10);
            nom[5] = ',';
            nom[6] = '0' + (freq_tempo %   10);
            nom[7] = ' ';
            memcpy(mem[mem_active].nom,nom,8);
            mem[mem_active].nom_ok = 1;
            mem_refresh = 1;
         }
         if (flag_rds == 1)
         {
            Si4703_ReadRDS(&drds);
            if ((drds.ps_ok) && (drds.erreur_1 < 2))
            {
               aff_nom(x_nom,y_nom,&drds);
               if ((mem_active < 8 ) && (mem[mem_active].etat == 1) && (mem[mem_active].nom_ok < 2))
               {
                  strcpy(mem[mem_active].nom,drds.ps);
                  mem[mem_active].nom_ok = 2;
                  mem_refresh = 1;
               }
            }
            if ((drds.rt_ok) && (drds.erreur_2 == 0))
            {
               rtrds.taille = tab_string(drds.rt,&rtrds.bit_chaine);
            }
            if ((drds.heure_ok) && (drds.erreur_2 == 0))
            {
               heure_rds(&drds,&hrds);
               heure_ete_hiver(&hrds);
               date_heure(&hrds,&d_jour);
               jour_sem(&hrds);
             }
          }
          if ((drds.heure_ok) && (heure_auto)) // heure du pic = heure RDS
          {
             gestion_heure(&hpic,&hrds);
             heure_auto = 0;
          }
          if (rtrds.taille > 0 )
          {
             rtrds.delta = scroll;
             aff_tab_mat_2x2(&rtrds);
             scroll++;
             if (scroll >= rtrds.taille) scroll = 0;
          }
          aff_icone(69,4);
          if (mem_active < 8)
          {
             if ((mem[mem_active].nom_ok == 1) && (mem_refresh == 1))
             {
                test_mem(&jeu_mem,&mem,frequence);
                aff_mem(jeu_mem,&mem);
                mem_refresh = 0;
             }
             if ((mem[mem_active].nom_ok == 2) && (mem_refresh == 1))
             {
                test_mem(&jeu_mem,&mem,frequence);
                aff_mem(jeu_mem,&mem);
                mem_refresh = 0;
             }
          }
      }
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
        if ((flag_pwr == 0) && (TFT_y > 100))
        {
           TFT_FadeIn(100);
        }
/*----------------------------------------------------------------------------*/
        if ((flag_pwr == 0) && (tft_x > 200) && (tft_y < 40))
        {
           TFT_FadeOut(100);
           Reset();
        }
/*----------------------------------------------------------------------------*/
        if (tft_x < 65)
        {
           if ((tft_y > 0) && (tft_y < 60)) // Touche Power
           {
              if (flag_pwr == 0)
              {
                 TFT_FadeOut(100);
                 flag_pwr = 1;
                 Si4703_WakeUp(volume,frequence);
                 Si4703_SetSensib(sensibilite);
                 aff_tuner_on();
                 mem_refresh = 1;
                 TFT_FadeIn(100);
                 flag_frequence = 1;
                 while(TP_TFT_Press_Detect());
                 Stereo_ShutDown(ON);
                 Mono_ShutDown(ON);
              }
              else
              {
                 Stereo_ShutDown(OFF);
                 Mono_ShutDown(OFF);
                 TFT_FadeOut(100);
                 for (i = 0 ; i < 8 ; i++)
                 {
                   strcpy(nom, mem[i].nom);
                   for (j = 0 ; j < 8 ; j++)
                   {
                      eprom_2[AD_NOM_1 + (16 * i) + j] = nom[j];
                   }
                   eprom_2[AD_NOM_OK + i] = mem[i].nom_ok;
                 }
                 eprom_0[AD_H_AUTO]    = heure_auto;
                 eprom_0[AD_VOLUME]    = volume;
                 eprom_1[AD_FREQUENCE] = frequence;
                 SerialFlash_SectorErase(SEC_0);
                 SerialFlash_SectorErase(SEC_1);
                 SerialFlash_SectorErase(SEC_2);
                 SerialFlash_WriteArray(SEC_0,&eprom_0,T_EEPROM);
                 SerialFlash_WriteArray(SEC_1,&eprom_1,T_EEPROM * 2);
                 SerialFlash_WriteArray(SEC_2,&eprom_2,T_NOM);
                 flag_pwr = 0;
                 flag_mute = 0;
                 TFT_refresh = 1;
                 Si4703_Sleep();
                 aff_tuner_off();
                 TFT_FadeIn(100);
                 tempo_sec = 0;
                 while(TP_TFT_Press_Detect())
                 {
                    if (tempo_sec > 2)
                    {
                       TFT_FadeOut(500);
                       while(TP_TFT_Press_Detect());
                    }
                 }
              }
           }
        }
/*----------------------------------------------------------------------------*/
        if (flag_pwr == 1)
        {
           if (tft_x < 65)
           {
             if ((tft_y >= 60) && (tft_y < 120)) // Touche Vol UP
             {
                TFT_image(0,60,Vol_UP_FOCUS,1);
                if ((volume < 30) && (flag_mute == 0))
                {
                  volume++;
                  Si4703_SetVolume(volume);
                }
                delay_ms(100);
                TFT_image(0,60,Vol_UP_ON,1);
             }
             if ((tft_y >= 120) && (tft_y < 180)) // Touche Mute
             {
                TFT_image(0,120,Vol_MUTE_FOCUS,1);
                if (flag_mute == 0)
                {
                   flag_mute = 1;
                   Si4703_SetVolume(0);
                }
                else
                {
                   flag_mute = 0;
                   Si4703_SetVolume(volume);
                }
                while(TP_TFT_Press_Detect());
                TFT_image(0,120,Vol_MUTE_ON,1);
             }
             if ((tft_y >= 180) && (tft_y < 240)) // Touche Vol DWN
             {
                TFT_image(0,180,Vol_DWN_FOCUS,1);
                if ((volume > 0) && (flag_mute == 0))
                {
                   volume--;
                   Si4703_SetVolume(volume);
                }
                delay_ms(100);
                TFT_image(0,180,Vol_DWN_ON,1);
             }
           }
/*----------------------------------------------------------------------------*/
           if (tft_y > 180)
           {
             if ((tft_x >= 103) && (tft_x < 163)) // Touche Seek DWN
             {
                drds.cnt_ps_trame = 0;
                TFT_image(103,180,Seek_DWN_FOCUS,1);
                tempo_sec = 0;
                while(TP_TFT_Press_Detect())
                {
                   if (tempo_sec > 1)
                   {
                      frequence--;
                      if (frequence < 875) frequence = 1080;
                      Si4703_SetChannel(frequence);
                      aff_frequence(x_freq,y_freq,frequence);
                      delay_ms(50);
                   }
                }
                if (tempo_sec < 1)
                {
                   Si4703_Seek(SEEK_DOWN);
                   frequence = Si4703_GetChannel();
                   flag_frequence = 1;
                }
                memset(drds.rt,' ',64);
                rtrds.taille = tab_string(drds.rt,&rtrds.bit_chaine);
                TFT_image(103,180,Seek_DWN_ON,1);
                mem_refresh = 1;
             }
             if ((tft_x >= 163) && (tft_x < 223)) // Touche SETUP
             {
                TFT_image(163,180,SETUP_FOCUS,1);
                tempo_sec = 0;
                while(TP_TFT_Press_Detect())
                {
                   if (tempo_sec > 2)     // Menu SETUP
                   {
                      aff_setup();
                      menu_setup(&mem,&hpic,&jour,&mois,&heure_auto);
                      TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
                      aff_tuner_on();
                      mem_refresh = 1;
                      flag_frequence = 1;
                      while(TP_TFT_Press_Detect());
                   }
                }
                if (tempo_sec < 2)        // change jeu mem
                {
                   if (jeu_mem == 0)
                   {
                      jeu_mem = 1;
                   }
                   else
                   {
                      jeu_mem = 0;
                   }
                   eprom_0[AD_JEU_MEM] = (unsigned short)jeu_mem;
                   aff_mem(jeu_mem,&mem);
                }
                TFT_image(163,180,SETUP_ON,1);
             }
             if ((tft_x >= 223) && (tft_x < 283)) // Touche Seek UP
             {
                drds.cnt_ps_trame = 0;
                TFT_image(223,180,Seek_UP_FOCUS,1);
                tempo_sec = 0;
                while(TP_TFT_Press_Detect())
                {
                   if (tempo_sec > 2)
                   {
                      frequence++;
                      if (frequence >1080) frequence = 875;
                      Si4703_SetChannel(frequence);
                      aff_frequence(x_freq,y_freq,frequence);
                      delay_ms(50);
                   }
                }
                if (tempo_sec < 2)
                {
                   Si4703_Seek(SEEK_UP);
                   frequence = Si4703_GetChannel();
                   flag_frequence = 1;
                }
                memset(drds.rt,' ',64);
                rtrds.taille = tab_string(drds.rt,&rtrds.bit_chaine);
                TFT_image(223,180,Seek_UP_ON,1);
                mem_refresh = 1;
              }
           }
/*----------------------------------------------------------------------------*/
           if ((tft_y < 180) && (tft_y > 120))
           {
              for (i = 0 ; i < 8 ; i++) mem[i].etat = 0;

              if ((tft_x >= 70) && (tft_x < 134)) // Touche Mem 1
              {
                 TFT_image(71,120,Mem_FOCUS,1);
                 tempo_sec = 0;
                 while(TP_TFT_Press_Detect())
                 {
                    if (tempo_sec > 2)
                    {
                       aff_mem_text(0,&mem,"Memorise");
                       mem[(4 * jeu_mem)].freq = frequence;
                       mem[(4 * jeu_mem)].etat = 1;
                       mem[(4 * jeu_mem)].nom_ok = 0;
                       eprom_1[AD_MEM_0+ (4 * jeu_mem)] = frequence;
                       delay_ms(100);
                    }
                 }
                 if (tempo_sec < 2)
                 {
                    if (mem[(4 * jeu_mem)].freq != 0)
                    {
                       frequence = mem[(4 * jeu_mem)].freq;
                       Si4703_SetChannel(frequence);
                       aff_frequence(x_freq,y_freq,frequence);
                       mem[(4 * jeu_mem)].etat = 1;
                    }
                 }
                 TFT_image(71,120,Mem_ON,1);
                 mem_active = 4 * jeu_mem;
             }
             if ((tft_x >= 134) && (tft_x < 197)) // Touche Mem 2
             {
                 TFT_image(134,120,Mem_FOCUS,1);
                 tempo_sec = 0;
                 while(TP_TFT_Press_Detect())
                 {
                    if (tempo_sec > 2)
                    {
                       aff_mem_text(1,&mem,"Memorise");
                       mem[(4 * jeu_mem) + 1].freq = frequence;
                       mem[(4 * jeu_mem) + 1].etat = 1;
                       mem[(4 * jeu_mem) + 1].nom_ok = 0;
                       eprom_1[AD_MEM_1+ (4 * jeu_mem)] = frequence;
                       delay_ms(100);
                    }
                 }
                 if (tempo_sec < 2)
                 {
                    if (mem[(4 * jeu_mem) + 1].freq != 0)
                    {
                       frequence = mem[(4 * jeu_mem) + 1].freq;
                       Si4703_SetChannel(frequence);
                       aff_frequence(x_freq,y_freq,frequence);
                       mem[(4 * jeu_mem) + 1].etat = 1;
                    }
                 }
                 TFT_image(134,120,Mem_ON,1);
                 mem_active = (4 * jeu_mem) + 1;
             }
             if ((tft_x >= 197) && (tft_x < 260)) // Touche Mem 3
             {
                 TFT_image(197,120,Mem_FOCUS,1);
                 tempo_sec = 0;
                 while(TP_TFT_Press_Detect())
                 {
                    if (tempo_sec > 2)
                    {
                       aff_mem_text(2,&mem,"Memorise");
                       mem[(4 * jeu_mem) + 2].freq = frequence;
                       mem[(4 * jeu_mem) + 2].etat = 1;
                       mem[(4 * jeu_mem) + 2].nom_ok = 0;
                       eprom_1[AD_MEM_2+ (4 * jeu_mem)] = frequence;
                       delay_ms(100);
                    }
                 }
                 if (tempo_sec < 2)
                 {
                    if (mem[(4 * jeu_mem) + 2].freq != 0)
                    {
                       frequence = mem[(4 * jeu_mem) + 2].freq;
                       Si4703_SetChannel(frequence);
                       aff_frequence(x_freq,y_freq,frequence);
                       mem[(4 * jeu_mem) + 2].etat = 1;
                    }
                 }
                 TFT_image(197,120,Mem_ON,1);
                 mem_active = (4 * jeu_mem) + 2;
             }
             if (tft_x >= 260)                      // Touche Mem 4
             {
                 TFT_image(260,120,Mem_FOCUS,1);
                 tempo_sec = 0;
                 while(TP_TFT_Press_Detect())
                 {
                    if (tempo_sec > 2)
                    {
                       aff_mem_text(3,&mem,"Memorise");
                       mem[(4 * jeu_mem) + 3].freq = frequence;
                       mem[(4 * jeu_mem) + 3].etat = 1;
                       mem[(4 * jeu_mem) + 3].nom_ok = 0;
                       eprom_1[AD_MEM_3+ (4 * jeu_mem)] = frequence;
                       delay_ms(100);
                    }
                 }
                 if (tempo_sec < 2)
                 {
                    if (mem[(4 * jeu_mem) + 3].freq != 0)
                    {
                       frequence = mem[(4 * jeu_mem) + 3].freq;
                       Si4703_SetChannel(frequence);
                       aff_frequence(x_freq,y_freq,frequence);
                       mem[(4 * jeu_mem) + 3].etat = 1;
                    }
                 }
                 TFT_image(260,120,Mem_ON,1);
                 mem_active = (4 * jeu_mem) + 3;
             }
             mem_refresh = 1;
             eprom_0[AD_MEM_ACT] = mem_active;
             memset(drds.rt,' ',64);
             rtrds.taille = tab_string(drds.rt,&rtrds.bit_chaine);
           }
/*----------------------------------------------------------------------------*/
        }
      }
   }
}
//------------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
////                              Fonctions                                 ////
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche tuner eteint                               ////
void aff_tuner_off()
{
   TFT_image(0,0,PWR_ON,1);
   TFT_image(0,60,Vol_UP_OFF,1);
   TFT_image(0,120,Vol_MUTE_OFF,1);
   TFT_image(0,180,Vol_DWN_OFF,1);
   TFT_image(103,180,Seek_DWN_OFF,1);
   TFT_image(163,180,SETUP_OFF,1);
   TFT_image(223,180,Seek_UP_OFF,1);
   TFT_image(71,120,Mem_OFF,1);
   TFT_image(134,120,Mem_OFF,1);
   TFT_image(197,120,Mem_OFF,1);
   TFT_image(260,120,Mem_OFF,1);
   TFT_image(66,0,Ecran_OFF,1);
   aff_mire_fond_ecran_off(70,4);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche tuner allum                               ////
void aff_tuner_on()
{

   TFT_image(0,0,PWR_OFF,1);
   TFT_image(0,60,Vol_UP_ON,1);
   TFT_image(0,120,Vol_MUTE_ON,1);
   TFT_image(0,180,Vol_DWN_ON,1);
   TFT_image(103,180,Seek_DWN_ON,1);
   TFT_image(163,180,SETUP_ON,1);
   TFT_image(223,180,Seek_UP_ON,1);
   TFT_image(71,120,Mem_ON,1);
   TFT_image(134,120,Mem_ON,1);
   TFT_image(197,120,Mem_ON,1);
   TFT_image(260,120,Mem_ON,1);
   TFT_image(66,0,Ecran_ON,1);
   aff_mire_fond_ecran_on(69,26);
   aff_icone(69,4);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche bas menu setup                             ////
void aff_setup()
{
   TFT_image(0,0,PWR_OFF,1);
   TFT_image(0,60,Vol_UP_ON,1);
   TFT_image(0,120,Vol_MUTE_ON,1);
   TFT_image(0,180,Vol_DWN_ON,1);
   TFT_image(103,180,Seek_DWN_ON,1);
   TFT_image(163,180,SETUP_ON,1);
   TFT_image(223,180,Seek_UP_ON,1);
   TFT_image(71,120,Mem_ON,1);
   TFT_image(134,120,Mem_ON,1);
   TFT_image(197,120,Mem_ON,1);
   TFT_image(260,120,Mem_ON,1);
   TFT_image(66,0,Ecran_ON,1);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche bas menu setup reglage heure               ////
void aff_setup_heure()
{
   TFT_image(0,0,PWR_OFF,1);
   TFT_image(0,60,Vol_UP_ON,1);
   TFT_image(0,120,Vol_MUTE_OFF,1);
   TFT_image(0,180,Vol_DWN_ON,1);
   TFT_image(103,180,Seek_DWN_OFF,1);
   TFT_image(163,180,SETUP_ON,1);
   TFT_image(223,180,Seek_UP_OFF,1);
   TFT_image(71,120,Mem_OFF,1);
   TFT_image(134,120,Mem_ON,1);
   TFT_image(197,120,Mem_ON,1);
   TFT_image(260,120,Mem_OFF,1);
   TFT_image(66,0,Ecran_ON,1);
   aff_mire_fond_ecran_on(69,26);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche bas menu setup reglage date                ////
void aff_setup_date()
{
   TFT_image(0,0,PWR_OFF,1);
   TFT_image(0,60,Vol_UP_ON,1);
   TFT_image(0,120,Vol_MUTE_OFF,1);
   TFT_image(0,180,Vol_DWN_ON,1);
   TFT_image(103,180,Seek_DWN_OFF,1);
   TFT_image(163,180,SETUP_ON,1);
   TFT_image(223,180,Seek_UP_OFF,1);
   TFT_image(71,120,Mem_OFF,1);
   TFT_image(134,120,Mem_ON,1);
   TFT_image(197,120,Mem_ON,1);
   TFT_image(260,120,Mem_ON,1);
   TFT_image(66,0,Ecran_ON,1);
   aff_mire_fond_ecran_on(69,26);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////            Gestion icone stereo - RDS                                  ////
void aff_icone(int x, int y)
{
   if (puissance > 6) puissance = 6;
   switch (puissance)
   {
      case 0 :
         TFT_image(x   ,y,S0G,1);
         TFT_image(x+5 ,y,S0G,1);
         TFT_image(x+10,y,S0G,1);
         TFT_image(x+15,y,S0G,1);
         TFT_image(x+20,y,S0G,1);
         TFT_image(x+25,y,S0G,1);
         
         TFT_image(x+49,y,S0D,1);
         TFT_image(x+54,y,S0D,1);
         TFT_image(x+59,y,S0D,1);
         TFT_image(x+64,y,S0D,1);
         TFT_image(x+69,y,S0D,1);
         TFT_image(x+74,y,S0D,1);
         break;
      case 1 :
         TFT_image(x   ,y,S0G,1);
         TFT_image(x+5 ,y,S0G,1);
         TFT_image(x+10,y,S0G,1);
         TFT_image(x+15,y,S0G,1);
         TFT_image(x+20,y,S0G,1);
         TFT_image(x+25,y,S1G,1);

         TFT_image(x+49,y,S1D,1);
         TFT_image(x+54,y,S0D,1);
         TFT_image(x+59,y,S0D,1);
         TFT_image(x+64,y,S0D,1);
         TFT_image(x+69,y,S0D,1);
         TFT_image(x+74,y,S0D,1);
         break;
      case 2 :
         TFT_image(x   ,y,S0G,1);
         TFT_image(x+5 ,y,S0G,1);
         TFT_image(x+10,y,S0G,1);
         TFT_image(x+15,y,S0G,1);
         TFT_image(x+20,y,S2G,1);
         TFT_image(x+25,y,S1G,1);

         TFT_image(x+49,y,S1D,1);
         TFT_image(x+54,y,S2D,1);
         TFT_image(x+59,y,S0D,1);
         TFT_image(x+64,y,S0D,1);
         TFT_image(x+69,y,S0D,1);
         TFT_image(x+74,y,S0D,1);
         break;
      case 3 :
         TFT_image(x   ,y,S0G,1);
         TFT_image(x+5 ,y,S0G,1);
         TFT_image(x+10,y,S0G,1);
         TFT_image(x+15,y,S3G,1);
         TFT_image(x+20,y,S2G,1);
         TFT_image(x+25,y,S1G,1);

         TFT_image(x+49,y,S1D,1);
         TFT_image(x+54,y,S2D,1);
         TFT_image(x+59,y,S3D,1);
         TFT_image(x+64,y,S0D,1);
         TFT_image(x+69,y,S0D,1);
         TFT_image(x+74,y,S0D,1);
         break;
      case 4 :
         TFT_image(x   ,y,S0G,1);
         TFT_image(x+5 ,y,S0G,1);
         TFT_image(x+10,y,S4G,1);
         TFT_image(x+15,y,S3G,1);
         TFT_image(x+20,y,S2G,1);
         TFT_image(x+25,y,S1G,1);

         TFT_image(x+49,y,S1D,1);
         TFT_image(x+54,y,S2D,1);
         TFT_image(x+59,y,S3D,1);
         TFT_image(x+64,y,S4D,1);
         TFT_image(x+69,y,S0D,1);
         TFT_image(x+74,y,S0D,1);
         break;
      case 5 :
         TFT_image(x   ,y,S0G,1);
         TFT_image(x+5 ,y,S5G,1);
         TFT_image(x+10,y,S4G,1);
         TFT_image(x+15,y,S3G,1);
         TFT_image(x+20,y,S2G,1);
         TFT_image(x+25,y,S1G,1);

         TFT_image(x+49,y,S1D,1);
         TFT_image(x+54,y,S2D,1);
         TFT_image(x+59,y,S3D,1);
         TFT_image(x+64,y,S4D,1);
         TFT_image(x+69,y,S5D,1);
         TFT_image(x+74,y,S0D,1);
         break;
      case 6 :
         TFT_image(x   ,y,S6G,1);
         TFT_image(x+5 ,y,S5G,1);
         TFT_image(x+10,y,S4G,1);
         TFT_image(x+15,y,S3G,1);
         TFT_image(x+20,y,S2G,1);
         TFT_image(x+25,y,S1G,1);

         TFT_image(x+49,y,S1D,1);
         TFT_image(x+54,y,S2D,1);
         TFT_image(x+59,y,S3D,1);
         TFT_image(x+64,y,S4D,1);
         TFT_image(x+69,y,S5D,1);
         TFT_image(x+74,y,S6D,1);
   }
   if (flag_stereo) TFT_image(x+31,y,stereo_on,1);
   else TFT_image(x+31,y,stereo_off,1);
   if (flag_logo_rds) TFT_image(x+100,y,RDS_ON,1);
   else TFT_image(x+100,y,RDS_OFF,1);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////            Gestion icone mmoire et nom/frequence station              ////
void aff_mem(char jeu, memoire *btn)
{
   short    i;
   short    j;
   short    k;
   unsigned x,y;
   char    *carac;



   if (jeu == 0) i = 0;
   else i = 4;
   for (j = 0; j < 4; j++)
   {
      x = (btn + i)->x;
      y = (btn + i)->y;
      for (k = 0 ; k < 60 ; k++) TFT_image(x - 17 + k,y - 42,Ecran_ON_barre_bas,1);
      if ((btn + i)->freq == 0) TFT_image(x - 17,y - 16,Mem_ON,1);
      else
      {
         carac = &((btn + i)->nom);
         for (k = 0; k < 8 ; k++) TFT_Write_Char(*carac++,x - 17 + (k * 7), y - 42);
         if ((btn + i)->etat)
         {
            TFT_image(x,y,(btn + i)->img_on,1);
         }
         else 
         {
         TFT_image(x,y,(btn + i )->img_off,1);
         }
      }
      i++;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////            Gestion icone mmoire                                       ////
void test_mem(char *jeu, memoire *btn, unsigned freq)
{
   short j;

   for (j = 0; j < 8; j++)
   {
      if ((btn + j)->freq == freq)
      {
         (btn + j)->etat = 1;
         if (j < 4) *jeu = 0;
         else *jeu = 1;
      }
      else
      {
         (btn + j)->etat = 0;
      }
   }
   eprom_0[AD_JEU_MEM] = (unsigned short)*jeu;
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////            Affiche Mmoris                                            ////
void aff_mem_text(short i, memoire *btn, char *carac)
{
   short    k;
   unsigned x,y;

   TFT_Set_Font(&Monospaced_8, CL_RED, FO_HORIZONTAL);
   x = (btn + i)->x;
   y = (btn + i)->y;
   for (k = 0 ; k < 60 ; k++) TFT_image(x - 17 + k,y - 42,Ecran_ON_barre_bas,1);
   for (k = 0; k < 8 ; k++) TFT_Write_Char(*(carac + k),x - 17 + (k * 7), y - 42);
   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
}
////                                                                       ////
///////////////////////////////////////////////////////////////////////////////
////                                                                       ////
void jour_sem(heudat *heur)
{
   short d,m,y;

   d = heur->dd;
   m = heur->mo;
   y = heur->yy;

   heur->jj = (d+=m<3?y--:y-2, 23*m/9 + d + 4 + y/4 -y/100 + y/400)%7;
}
////                                                                       ////
///////////////////////////////////////////////////////////////////////////////
////                                                                       ////
short bissextile(heudat *heur)
{
   return ((((heur->yy % 4) == 0) && ((heur->yy % 100) != 0)) || ((heur->yy % 400) == 0));
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////             Calcul si heure t/hiver                                  ////
void heure_ete_hiver(heudat *heur)
{
   if ((heur->mo > 3) || ((heur->mo == 3) && (heur->dd > 24) && (heur->jj >= 0) && (heur->hh >= 2)))
   {
      heur->ete_hiver = 0;
   }
   if (((heur->mo > 10) || (heur->mo < 3)) || ((heur->mo == 10) && (heur->dd > 24) && (heur->jj >= 0) && (heur->hh >= 3)))
   {
      heur->ete_hiver = 1;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////    correction date et heure en fonction du fuseau et anne bissextile  ////
void date_heure(heudat *heur, char *d_j)
{
   char tempo;

   if   (bissextile(heur)) d_j[1] = 29;
   else d_j[1] = 28;
   
   heur->hh += heur->fuseau;
   if (heur->hh < 0)
   {
      heur->hh += 24;
      heur->dd--;
      if (heur->dd == 0)
      {
         heur->mo--;
         if (heur->mo == 0)
         {
            heur->mo = 12;
            heur->yy--;
         }
         tempo = d_j[heur->mo];
         heur->dd = tempo;
      }
   }
   if (heur->hh > 23)
   {
      heur->hh -= 24;
      heur->dd++;
      if (heur->dd > d_j[heur->mo])
      {
         heur->dd = 1;
         heur->mo++;
         if (heur->mo > 12)
         {
            heur->mo = 1;
            heur->yy++;
         }
      }
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////            Gestion de l'heure du PIC                                   ////
short heure_pic(heudat *hpic)
{
   unsigned long time_pic;
   unsigned long date_pic;
   short         sve_jour;
   short         sve_heure;
   short         sve_minute;

   sve_jour   = hpic->dd;
   sve_heure  = hpic->hh;
   sve_minute = hpic->mm;
   time_pic   = Read_Time();
   date_pic   = Read_Date();
   hpic->hh   = Read_Heure(time_pic);
   hpic->mm   = Read_Minute(time_pic);
   hpic->ss   = Read_Seconde(time_pic);
   hpic->jj   = Read_Jour_Sem(date_pic);
   hpic->dd   = Read_Jour(date_pic);
   hpic->mo   = Read_Mois(date_pic);
   hpic->yy   = Read_Annee(date_pic);
   if ((sve_heure == hpic-> hh) && (sve_minute == hpic-> mm)) hpic->change = 0;
   else hpic->change = 1;
   if (sve_jour != hpic->dd) return (1);
   else return (0);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////            Gestion de l'heure du RDS                                   ////
void heure_rds(rds *trame, heudat *hrds)
{
   hrds->hh     = trame->hh;
   hrds->mm     = trame->mm;
   hrds->ss     = 0;
   hrds->dd     = trame->dd;
   hrds->mo     = trame->mo;
   hrds->yy     = trame->yy - 100;
   hrds->fuseau = trame->fuseau;
   
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////            Gestion et calcul de l'heure                                ////
char gestion_heure(heudat *hpic, heudat *hrds)
{
   char new;

   new = 0;
   if ((hrds->hh != hpic->hh) || (hrds->mm != hpic->mm))
   {
      Write_RTCC_HHMMSS(hrds->hh,hrds->mm,hrds->ss);
      if ((hrds->dd != hpic->dd) || (hrds->mo != hpic->mo) || (hrds->yy != hpic->yy))
      {
         Write_RTCC_YYMMDDJS(hrds->jj,hrds->dd,hrds->mo,hrds->yy);
        new = 1;
      }
      heure_pic(hpic);
   }
   return new;
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche la ligne de la date sur le fond de l'cran             ////
////                                                                        ////
void aff_date_ecran_off(int x, int y, heudat *heur, ch_txt_17 *jour, ch_txt_17 *mois)
{
   char chaine[] = "          ";
   car_mat car;
   char i;
   char ecart;

   ecart = 24;
   car.c_t = 0x9D97;
   car.c_c = 0x9D97;//DF7F;
   car.f_t = 0x5B6E;
   car.f_c = 0x6C11;

   car.x = x;
   car.y = y;

   chaine[0] = 0;
   strcat(chaine,jour[heur->jj]);
   strcat(chaine," ");
   chaine[4] = '0' + (heur->dd / 10);
   chaine[5] = '0' + (heur->dd % 10);
   chaine[6] = 0;
   strcat(chaine," ");
   strcat(chaine,mois[heur->mo]);

   car.x = x;
   car.y = y;
   
   for (i = 0; i < 10 ; i++)
   {
     car.carac = chaine[i];
     aff_carac_mat(&car);
     car.x += ecart;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche l'heure sur le fond de l'cran  OFF                    ////
////                                                                        ////
void aff_heure_ecran_off(int x, int y,heudat *heur,short top_s)
{
   car_mat car;

   car.x = x;
   car.y = y;
   car.c_t = 0x9D97; //0xC6DC;
   car.c_c = 0xDF7F;
   car.f_t = 0x5B6E;
   car.f_c = 0x6C11;
   
   car.carac = '0' + (heur->hh / 10);
   aff_carac_mat_rockwell(&car,4,18);
   car.x += 52;
   car.carac = '0' + (heur->hh % 10);
   aff_carac_mat_rockwell(&car,4,18);
   car.x += 52;
   if (top_s) car.carac = ':';
   else car.carac = ' ';
   aff_carac_mat_rockwell(&car,4,18);
   car.x += 28;
   car.carac = '0' + (heur->mm / 10);
   aff_carac_mat_rockwell(&car,4,18);
   car.x += 52;
   car.carac = '0' + (heur->mm % 10);
   aff_carac_mat_rockwell(&car,4,18);

}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche l'heure sur le fond de l'cran ON                      ////
////                                                                        ////
void aff_heure_ecran_on(int x_c, int y,heudat *heur,short top_s)
{
   char  i;
   int   x_digit[] = {50,35,15,0};
   int   x;
   char  digit[] = {0,0,0,0};
   short hh,mm;
   short tempo;

   hh  = heur->hh;
   mm  = heur->mm;
   digit[3] = (hh / 10);
   digit[2] = hh % 10;
   digit[1] = (mm / 10);
   digit[0] = mm % 10;
   for (i=0;i<4;++i)
   {
      x = x_c + x_digit[i];
      TFT_image(x,y,*(digit_heure + digit[i]),1);
   }
   x = x_c + x_digit[1] - 5;
   tempo = 10 + (1 * (top_s & 0x0001));
   TFT_image(x,y,digit_heure[tempo],1);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche l'heure dans le menu de rglage manuel                 ////
////                                                                        ////
void aff_heure_ecran_reglage(int x, int y,heudat *heur,short top_s)
{
   car_mat car;
   char ecart;

   ecart = 33;
   car.c_t = 0x0000;
   car.c_c = 0x00EA;
   car.f_t = 0x0000;
   car.f_c = 0xBEBD;

   car.x = x;
   car.y = y;

   car.carac = '0' + (heur->hh / 10);
   aff_carac_mat_4x2x2(&car);
   car.x += ecart;
   car.carac = '0' + (heur->hh % 10);
   aff_carac_mat_4x2x2(&car);
   car.x += ecart + 3;
   if (top_s) car.carac = ':';
   else car.carac = ' ';
   aff_carac_mat_4x2x2(&car);
   car.x += ecart;
   car.carac = '0' + (heur->mm / 10);
   aff_carac_mat_4x2x2(&car);
   car.x += ecart;
   car.carac = '0' + (heur->mm % 10);
   aff_carac_mat_4x2x2(&car);
   car.x += ecart;
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche l'heure dans le menu de rglage manuel                 ////
////                                                                        ////
void aff_date_ecran_reglage(int x, int y,heudat *heur, ch_txt_17 *jour, ch_txt_17 *mois)
{
   car_mat car;
   char ecart;
   char chaine[] = "         ";
   char i;
   
   ecart = 18;
   car.c_t = 0x0000;
   car.c_c = 0x00EA;
   car.f_t = 0x0000;
   car.f_c = 0xBEBD;

   car.x = x;
   car.y = y;

   chaine[0] = 0;
   strcat(chaine,jour[heur->jj]);
   for (i = 0; i < 3 ; i++)
   {
     car.carac = chaine[i];
     aff_carac_mat_2x2(&car);
     car.x += ecart;
   }
   car.x += 9;
   car.carac = '0' + (heur->dd / 10);
   aff_carac_mat_2x2(&car);
   car.x += ecart;
   car.carac = '0' + (heur->dd % 10);
   aff_carac_mat_2x2(&car);
   car.x += ecart;
   car.x += 9;
   
   chaine[0] = 0;
   strcat(chaine,mois[heur->mo]);
   for (i = 0; i < 3 ; i++)
   {
     car.carac = chaine[i];
     aff_carac_mat_2x2(&car);
     car.x += ecart;
   }
   car.x += 9;

   car.carac = '2';
   aff_carac_mat_2x2(&car);
   car.x += ecart;
   car.carac = '0';
   aff_carac_mat_2x2(&car);
   car.x += ecart;
   car.carac = '0' + (heur->yy / 10);
   aff_carac_mat_2x2(&car);
   car.x += ecart;
   car.carac = '0' + (heur->yy % 10);
   aff_carac_mat_2x2(&car);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche la mire de fond de l'cran                             ////
////                                                                        ////
void aff_mire_fond_ecran_off(int x, int y)
{
   pix_mat pix;
   char i,j;

   pix.x = x;
   pix.y = y;
   pix.c_t = 0x5B6E;
   pix.c_c = 0x6C11;
   
   for (j = 0; j < 27  ; j++)
   {
      for (i = 0; i < 62 ; i++)
      {
         aff_pix_mat(&pix);
         pix.x += 4;
      }
      pix.y += 4;
      pix.x = x;
   }
}
/////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche la mire de fond de l'cran                             ////
////                                                                        ////
void aff_mire_fond_ecran_on(int x, int y)
{
   pix_mat pix;
   char i,j;

   pix.x = x;
   pix.y = y;
   pix.c_t = 0x5B6E;
   pix.c_c = 0xBEBD;

   for (j = 0; j < 21  ; j++)
   {
      for (i = 0; i < 83 ; i++)
      {
         aff_pix_2x2_mat(&pix);
         pix.x += 3;
      }
      pix.y += 3;
      pix.x = x;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche la frquence                                           ////
////                                                                        ////
void aff_frequence(int x, int y, unsigned freq)
{
   char chaine[] = "                 ";
   car_mat car;
   char i;
   char ecart;

   ecart = 18;
   car.c_t = 0x0000;
   car.c_c = 0x00EA;
   car.f_t = 0x0000;
   car.f_c = 0xBEBD;

   car.x = x;
   car.y = y;

   if (freq < 1000) chaine [0] = ' ';
   else chaine[0] = '0' + (freq / 1000);
   freq %= 1000;
   chaine[1] = '0' + (freq /  100);
   freq %= 100;
   chaine[2] = '0' + (freq /   10);
   chaine[3] = ',';
   chaine[4] = '0' + (freq %   10);
   chaine[5] = ' ';
   chaine[6] = 'M';
   chaine[7] = 'h';
   chaine[8] = 'z';
   chaine[9] = ' ';
   chaine[10] = ' ';
   chaine[11] = ' ';
   chaine[12] = ' ';
   chaine[13] = ' ';

   car.x = x;
   car.y = y;

   for (i = 0; i < 14 ; i++)
   {
     car.carac = chaine[i];
     aff_carac_mat_2x2(&car);
     car.x += ecart;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affiche le nom de la radio                                     ////
////                                                                        ////
void aff_nom(int x, int y, rds *trame)
{
   char chaine[] = "         ";
   car_mat car;
   char i;
   char ecart;

   
   ecart = 18;
   car.c_t = 0x0000;
   car.c_c = 0x00EA;
   car.f_t = 0x0000;
   car.f_c = 0xBEBD;

   car.x = x;
   car.y = y;

   strncpy(chaine,trame->ps,8);
   car.x = x;
   car.y = y;

   for (i = 0; i < 9 ; i++)
   {
      if (iscntrl(chaine[i])) car.carac = ' ';
      else car.carac = chaine[i];
      aff_carac_mat_2x2(&car);
      car.x += ecart;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Affichage Menu_setup                                           ////
////                                                                        ////
void aff_menu_setup(memoire *btn)
{
   TFT_image(66,0,Ecran_ON,1);
   TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLUE, FO_HORIZONTAL);
   TFT_Write_Text("Configuration",130,3);
   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
   aff_mem_text(0,btn,"Reg Horl");
   aff_mem_text(1,btn,"Raz Mem ");
   aff_mem_text(2,btn,"Mon/Ster");
   aff_mem_text(3,btn,"Sensib..");
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Page de configuration                                          ////
////                                                                        ////
void menu_setup(memoire *btn, heudat *hpic, ch_txt_17 *jour,ch_txt_17 *mois, short *heure_auto)
{

   unsigned int tft_x, tft_y;
   char sortie_menu;

   aff_menu_setup(btn);
   
   sortie_menu = 0;
   while(TP_TFT_Press_Detect());
   while (sortie_menu == 0)
   {
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
/*----------------------------------------------------------------------------*/
         if (tft_y > 180)
         {
            if ((tft_x >= 163) && (tft_x < 223)) // Touche SETUP
            {
               TFT_image(163,180,SETUP_FOCUS,1);
               while(TP_TFT_Press_Detect());
               sortie_menu = 1;
               TFT_image(163,180,SETUP_ON,1);
            }
         }
/*----------------------------------------------------------------------------*/
         if ((tft_y < 180) && (tft_y > 120))
         {
            if ((tft_x >= 70) && (tft_x < 134)) // Touche Mem 1
            {
               TFT_image(71,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect());
               menu_heure(btn,hpic,jour,mois,heure_auto);
               aff_setup();
               aff_menu_setup(btn);
               TFT_image(71,120,Mem_ON,1);
            }
            if ((tft_x >= 134) && (tft_x < 197)) // Touche Mem 2
            {
               TFT_image(134,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect());
               menu_memoire(btn);
               aff_menu_setup(btn);
               TFT_image(134,120,Mem_ON,1);
            }
            if ((tft_x >= 197) && (tft_x < 260)) // Touche Mem 3
            {
               TFT_image(197,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect());
               menu_stereo(btn);
               aff_menu_setup(btn);
               TFT_image(197,120,Mem_ON,1);
            }
            if (tft_x >= 260)                      // Touche Mem 4
            {
               TFT_image(260,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect())
               menu_sensibilite(btn);
               aff_menu_setup(btn);
               TFT_image(260,120,Mem_ON,1);
            }
         }
/*----------------------------------------------------------------------------*/
      }
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         rglage de l'heure et de la date                               ////
////                                                                        ////
void menu_heure(memoire *mem, heudat *hpic, ch_txt_17 *jour,ch_txt_17 *mois, short *heure_auto)
{

   unsigned int tft_x, tft_y;
   char sortie_menu;

   aff_setup();

   TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLUE, FO_HORIZONTAL);
   TFT_Write_Text("Configuration",130,3);
   TFT_Write_Text("Reglage de l'heure et",100,35);
   TFT_Write_Text("de la date",140,65);
   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
   aff_mem_text(0,mem," MANUEL ");
   aff_mem_text(3,mem,"  AUTO  ");

   sortie_menu = 0;
   while(TP_TFT_Press_Detect());
   while (sortie_menu == 0)
   {
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
/*----------------------------------------------------------------------------*/
         if ((tft_y < 180) && (tft_y > 120))
         {
            if ((tft_x >= 70) && (tft_x < 134)) // Touche Mem 1
            {
               TFT_image(71,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect());
               heure_auto = 0;
               menu_reglage_heure(mem,hpic,jour,mois);

            }
            if (tft_x >= 260)                      // Touche Mem 4
            {
               TFT_image(260,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect())
               heure_auto = 1;
               TFT_image(260,120,Mem_ON,1);
            }
         }
         sortie_menu = 1;
/*----------------------------------------------------------------------------*/
      }
   }
   delay_ms(150);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Efface toutes les mmoires                                     ////
////                                                                        ////
void menu_memoire(memoire *mem)
{
   unsigned int tft_x, tft_y;
   short        i,j;
   char         nom[9];
   char         sortie_menu;
   
   aff_setup();

   TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLUE, FO_HORIZONTAL);
   TFT_Write_Text("Configuration",130,3);
   TFT_Write_Text("Effacement des",115,35);
   TFT_Write_Text("touches de sauvegarde",85,65);
   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
   aff_mem_text(0,mem,"   OUI  ");
   aff_mem_text(3,mem,"   NON  ");
   
   sortie_menu = 0;
   while(TP_TFT_Press_Detect());
   while (sortie_menu == 0)
   {
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
         if ((tft_x >= 70) && (tft_x < 134)) // Touche Mem 1
         {
            TFT_image(71,120,Mem_FOCUS,1);
            while(TP_TFT_Press_Detect());
            for (i = 0 ; i < T_EEPROM ; i++)
            {
               eprom_1[i] = 0;
            }
            for (i = 0 ; i < AD_NOM_1 ; i++)
            {
               eprom_2[i] = 0;
            }
            SerialFlash_SectorErase(SEC_1);
            SerialFlash_SectorErase(SEC_2);
            SerialFlash_WriteArray(SEC_2,&eprom_2,T_NOM);
            for (i=0 ; i < 8 ; i++)
            {
              mem[i].etat = 0;
              mem[i].freq     =  0;
              for (j = 0 ; j < 8 ; j++)
              {
                 nom[j] = eprom_2[AD_NOM_1 + (16 * i) + j];
              }
              nom[8] = '\0';
              strcpy(mem[i].nom,nom);
              mem[i].nom_ok = 0;
            }
            delay_ms(500);
            sortie_menu = 1;
            TFT_image(71,120,Mem_ON,1);
         }
         if (tft_x >= 260)                      // Touche Mem 4
         {
            TFT_image(260,120,Mem_FOCUS,1);
            while(TP_TFT_Press_Detect())
            sortie_menu = 1;
            TFT_image(260,120,Mem_ON,1);
         }
      }
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         Force le mode stro ou mono                                   ////
////                                                                        ////
void menu_stereo(memoire *mem)
{
   unsigned int tft_x, tft_y;
   short        i,j;
   char         nom[9];
   char         sortie_menu;

   aff_setup();

   TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLUE, FO_HORIZONTAL);
   TFT_Write_Text("Configuration",130,3);
   TFT_Write_Text("Type du signal",130,35);
   TFT_Write_Text(" MONO  ou  STEREO",100,65);
   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
   aff_mem_text(0,mem,"  MONO  ");
   aff_mem_text(3,mem," STEREO ");

   sortie_menu = 0;
   while(TP_TFT_Press_Detect());
   while (sortie_menu == 0)
   {
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
         if ((tft_x >= 70) && (tft_x < 134)) // Touche Mem 1
         {
            TFT_image(71,120,Mem_FOCUS,1);
            while(TP_TFT_Press_Detect());
            Si4703_Stereo(1); // force MONO
            delay_ms(500);
            sortie_menu = 1;
            TFT_image(71,120,Mem_ON,1);
         }
         if (tft_x >= 260)                      // Touche Mem 4
         {
            TFT_image(260,120,Mem_FOCUS,1);
            while(TP_TFT_Press_Detect())
            Si4703_Stereo(0); // force Auto Mono/stereo
            delay_ms(500);
            sortie_menu = 1;
            TFT_image(260,120,Mem_ON,1);
         }
      }
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         rglage de la sensibilit                                      ////
////                                                                        ////
void menu_sensibilite(memoire *mem)
{

   unsigned int tft_x, tft_y;
   char sortie_menu;

   
   aff_setup();

   TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLUE, FO_HORIZONTAL);
   TFT_Write_Text("Configuration",130,3);
   TFT_Write_Text("Seuil de filtrage de",110,35);
   TFT_Write_Text("la puissance du signal",100,65);
   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
   aff_mem_text(0,mem,"  SANS  ");
   aff_mem_text(1,mem," FAIBLE ");
   aff_mem_text(2,mem,"  MOYEN ");
   aff_mem_text(3,mem,"  FORT  ");

   sortie_menu = 0;
   while(TP_TFT_Press_Detect());
   while (sortie_menu == 0)
   {
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
/*----------------------------------------------------------------------------*/
         if (tft_y > 180)
         {
            if ((tft_x >= 163) && (tft_x < 223)) // Touche SETUP
            {
               TFT_image(163,180,SETUP_FOCUS,1);
               while(TP_TFT_Press_Detect());
               sortie_menu = 1;
               TFT_image(163,180,SETUP_ON,1);
            }
         }
/*----------------------------------------------------------------------------*/
         if ((tft_y < 180) && (tft_y > 120))
         {
            if ((tft_x >= 70) && (tft_x < 134)) // Touche Mem 1
            {
               TFT_image(71,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect());
               sensibilite = 0;
               TFT_image(71,120,Mem_ON,1);
            }
            if ((tft_x >= 134) && (tft_x < 197)) // Touche Mem 2
            {
               TFT_image(134,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect());
               sensibilite = 1;
               TFT_image(134,120,Mem_ON,1);
            }
            if ((tft_x >= 197) && (tft_x < 260)) // Touche Mem 3
            {
               TFT_image(197,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect());
               sensibilite = 2;
               TFT_image(197,120,Mem_ON,1);
            }
            if (tft_x >= 260)                      // Touche Mem 4
            {
               TFT_image(260,120,Mem_FOCUS,1);
               while(TP_TFT_Press_Detect())
               sensibilite = 3;
               TFT_image(197,120,Mem_ON,1);
            }
         }
         sortie_menu = 1;
/*----------------------------------------------------------------------------*/
      }
   }
   Si4703_SetSensib(sensibilite);
   delay_ms(150);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////         rglage manuel de l'heure                                      ////
////                                                                        ////
void menu_reglage_heure(memoire *mem, heudat *hpic, ch_txt_17 *jour,ch_txt_17 *mois)
{

   unsigned int tft_x, tft_y;
   char sortie_menu;
   short sve_flag_mute;
   heudat reg_heure;
   short hh_mm;
   short dd_mo_yy;
   char  d_jour[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
   
   sve_flag_mute = flag_mute;
   flag_mute = 0;
   hh_mm = 2;
   
   reg_heure.hh = hpic->hh;
   reg_heure.mm = hpic->mm;
   reg_heure.jj = hpic->jj;
   reg_heure.dd = hpic->dd;
   reg_heure.mo = hpic->mo;
   reg_heure.yy = hpic->yy;
    
   aff_setup_heure();

   TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLUE, FO_HORIZONTAL);
   TFT_Write_Text("   Horloge   ",130,3);

   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
   aff_mem_text(1,mem,"  HEURE ");
   aff_mem_text(2,mem," MINUTE ");

   sortie_menu = 0;
   while(TP_TFT_Press_Detect());
   while (sortie_menu == 0)
   {
      aff_heure_ecran_reglage(117, 41,&reg_heure,flag_sec);
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
         if ((tft_x < 65) && (hh_mm < 2))
         {
            if ((tft_y >= 60) && (tft_y < 120)) // Touche Vol UP
            {
               TFT_image(0,60,Vol_UP_FOCUS,1);
               if (hh_mm == 0)
               {
                  reg_heure.hh++;
                  if (reg_heure.hh > 23) reg_heure.hh = 0;
               }
               else
               {
                  reg_heure.mm++;
                  if (reg_heure.mm > 59) reg_heure.mm = 0;
               }
               delay_ms(250);
               TFT_image(0,60,Vol_UP_ON,1);
            }
            if ((tft_y >= 180) && (tft_y < 240)) // Touche Vol DWN
            {
               TFT_image(0,180,Vol_DWN_FOCUS,1);
               if (hh_mm == 0)
               {
                  if (reg_heure.hh == 0) reg_heure.hh = 24;
                  reg_heure.hh--;

               }
               else
               {
                  if (reg_heure.mm == 0) reg_heure.mm = 60;
                  reg_heure.mm--;

               }
               delay_ms(250);
               TFT_image(0,180,Vol_DWN_ON,1);
            }
         }
/*----------------------------------------------------------------------------*/
         if (tft_y > 180)
         {
            if ((tft_x >= 163) && (tft_x < 223)) // Touche SETUP
            {
               TFT_image(163,180,SETUP_FOCUS,1);
               while(TP_TFT_Press_Detect());
               sortie_menu = 1;
               TFT_image(163,180,SETUP_ON,1);
            }
         }
/*----------------------------------------------------------------------------*/
         if ((tft_y < 180) && (tft_y > 120))
         {
            if ((tft_x >= 134) && (tft_x < 197)) // Touche Mem 2
            {
               TFT_image(134,120,Mem_FOCUS,1);
               TFT_image(197,120,Mem_ON,1);
               hh_mm = 0;
               while(TP_TFT_Press_Detect());
            }
            if ((tft_x >= 197) && (tft_x < 260)) // Touche Mem 3
            {
               TFT_image(197,120,Mem_FOCUS,1);
               TFT_image(134,120,Mem_ON,1);
               hh_mm = 1;
               while(TP_TFT_Press_Detect());
            }
         }
/*----------------------------------------------------------------------------*/
      }
   }
   Write_RTCC_HHMMSS(reg_heure.hh,reg_heure.mm,hpic->ss);
/*----------------------------------------------------------------------------*/
   dd_mo_yy = 3;

   aff_setup_date();

   TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLUE, FO_HORIZONTAL);
   TFT_Write_Text(" Calendrier ",135,3);

   TFT_Set_Font(&Monospaced_8, CL_BLACK, FO_HORIZONTAL);
   aff_mem_text(1,mem,"  JOUR  ");
   aff_mem_text(2,mem,"  MOIS  ");
   aff_mem_text(3,mem,"  ANNEE ");
   
   if   (bissextile(&reg_heure)) d_jour[1] = 29;
   else d_jour[1] = 28;
   
   sortie_menu = 0;
   while(TP_TFT_Press_Detect());
   while (sortie_menu == 0)
   {
      jour_sem(&reg_heure);
      aff_date_ecran_reglage(75, 50,&reg_heure,jour,mois);
      if (TP_TFT_Get_Coordinates(&tft_x, &tft_y) == 0)
      {
         if ((tft_x < 65) && (dd_mo_yy < 3))
         {
            if ((tft_y >= 60) && (tft_y < 120)) // Touche Vol UP
            {
               TFT_image(0,60,Vol_UP_FOCUS,1);
               switch (dd_mo_yy)
               {
                  case 0 :
                     reg_heure.dd++;
                     if (reg_heure.dd > d_jour[reg_heure.mo-1]) reg_heure.dd = 1;
                     break;
                  case 1 :
                     reg_heure.mo++;
                     if (reg_heure.mo > 12) reg_heure.mo = 1;
                     if (reg_heure.dd > d_jour[reg_heure.mo-1]) reg_heure.dd = d_jour[reg_heure.mo-1];
                     break;
                  case 2 :
                     reg_heure.yy++;
                     if (reg_heure.yy > 99) reg_heure.yy = 0;
                     if (bissextile(&reg_heure)) d_jour[1] = 29;
                     else d_jour[1] = 28;
                     if (reg_heure.dd > d_jour[reg_heure.mo-1]) reg_heure.dd = d_jour[reg_heure.mo-1];
               }
               delay_ms(250);
               TFT_image(0,60,Vol_UP_ON,1);
            }
            if ((tft_y >= 180) && (tft_y < 240)) // Touche Vol DWN
            {
               TFT_image(0,180,Vol_DWN_FOCUS,1);
               switch (dd_mo_yy)
               {
                  case 0 :
                     if (reg_heure.dd == 1) reg_heure.dd = d_jour[reg_heure.mo-1];
                     reg_heure.dd--;
                     break;
                  case 1 :
                     if (reg_heure.mo == 1) reg_heure.mo = 12;
                     reg_heure.mo--;
                     if (reg_heure.dd > d_jour[reg_heure.mo-1]) reg_heure.dd = d_jour[reg_heure.mo-1];
                     break;
                  case 2 :
                     if (reg_heure.yy == 0) reg_heure.yy = 99;
                     reg_heure.yy--;
                     if (bissextile(&reg_heure)) d_jour[1] = 29;
                     else d_jour[1] = 28;
                     if (reg_heure.dd > d_jour[reg_heure.mo-1]) reg_heure.dd = d_jour[reg_heure.mo-1];
               }
               delay_ms(250);
               TFT_image(0,180,Vol_DWN_ON,1);
            }
         }
/*----------------------------------------------------------------------------*/
         if (tft_y > 180)
         {
            if ((tft_x >= 163) && (tft_x < 223)) // Touche SETUP
            {
               TFT_image(163,180,SETUP_FOCUS,1);
               while(TP_TFT_Press_Detect());
               sortie_menu = 1;
               TFT_image(163,180,SETUP_ON,1);
            }
         }
/*----------------------------------------------------------------------------*/
         if ((tft_y < 180) && (tft_y > 120))
         {
            if ((tft_x >= 134) && (tft_x < 197)) // Touche Mem 2
            {
               TFT_image(134,120,Mem_FOCUS,1);
               TFT_image(197,120,Mem_ON,1);
               TFT_image(260,120,Mem_ON,1);
               dd_mo_yy = 0;
               while(TP_TFT_Press_Detect());
            }
            if ((tft_x >= 197) && (tft_x < 260)) // Touche Mem 3
            {
               TFT_image(134,120,Mem_ON,1);
               TFT_image(197,120,Mem_FOCUS,1);
               TFT_image(260,120,Mem_ON,1);
               dd_mo_yy = 1;
               while(TP_TFT_Press_Detect());
            }
            if (tft_x >= 260)                    // Touche Mem 4
            {
               TFT_image(134,120,Mem_ON,1);
               TFT_image(197,120,Mem_ON,1);
               TFT_image(260,120,Mem_FOCUS,1);
               dd_mo_yy = 2;
               while(TP_TFT_Press_Detect());
            }
         }
/*----------------------------------------------------------------------------*/
      }
   }
   Write_RTCC_YYMMDDJS(reg_heure.jj,reg_heure.dd,reg_heure.mo,reg_heure.yy);
   flag_mute = sve_flag_mute;
}