////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////              Dclaration fonctions graphiques                          ////
////                                                                        ////
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                                                                        ////


////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
////              TFT_BackLight(char mode)                                  ////
////              mode : ON - OFF                                           ////
////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
  void TFT_BackLight(char mode)
{
   TFT_BLED_Direction = 0;
   TFT_BLED = mode;
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////  Function:  TFT_FadeIn(int msTime)                                     ////
////                                                                        ////
////  Overview: Fading on backlight screen                                  ////
////  Input:   msTime : Fading time in ms (mini 100 ms)                     ////
////                                                                        ////
void TFT_FadeIn(int msTime)
{
   unsigned w;
   unsigned t;
   unsigned i,j;
   unsigned duty = 0;
   // unsigned periode;
   // F = 1000 hz -> P = 0,001 s -> P/100 = 10 s

   if (msTime<100) msTime = 100;
   duty = 0;
   t = msTime/100;

   TFT_BLED_Direction = 0;
   for (w = 0; w < 100; w++){
     for (j = 0; j < t ; j++) {
       i = 0;
       TFT_BLED = 1;
       while (i < duty){
         delay_us(10);
         i++;
       }
       TFT_BLED = 0;
       while (i < 100){
         delay_us(10);
         i++;
       }
     }
     duty ++;
   }
   TFT_BackLight(ON);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////  Function:  TFT_FadeOut(int msTime)                                    ////
////                                                                        ////
////  Overview: Fading off backlight screen                                 ////
////  Input:    msTime : Fading time in ms (mini 100 ms)                    ////
////                                                                        ////
void TFT_FadeOut(unsigned msTime)
{
   unsigned w;
   unsigned t;
   unsigned duty = 0;
   unsigned periode;
   if (msTime<100) msTime = 100;
   periode = PWM_Init_Advanced(500, 80000, 3, 0, 2);
   duty = periode;
   t = msTime/100;
   PWM_Start(3);
   for( w=0; w<100; w++) {
      PWM_Set_Duty(duty,3);
      duty -= (periode/100);
      Vdelay_ms(t);
   }
   PWM_Stop(3);
   TFT_BackLight(OFF);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                                                                        ////
 ////                                                                        ////

////////////////////////////////////////////////////////////////////////////////
////        Affiche l'heure en grand                                        ////
////                                                                        ////
void TFT_Heure(heudat *heur)
{
   char  i;
   char  x_digit[] = {246,172,74,0};
   char  y_digit = 20;
   char  digit[] = {0,0,0,0};
   short hh,mm,ss;
   short tempo;
   ss = heur->ss;
   if (heur->change)
   {
     hh = heur->hh;
     mm = heur->mm;

     digit[3] = (hh / 10);
     digit[2] = hh % 10;
     digit[1] = (mm / 10);
     digit[0] = mm % 10;
     for (i=0;i<4;++i)
     {
        TFT_Image(x_digit[i],y_digit,(digit_heure[digit[i]]),1);
     }
   }
   tempo = 10 + (1 * (ss & 0x0001));
   TFT_Image(148,y_digit,digit_heure[tempo],1);
}

////////////////////////////////////////////////////////////////////////////////
////     Trace une ligne                                                    ////
////                                                                        ////
////     (x1, y1) - coordonnes de dpart                                   ////
////     (x2, y2) - coordonnes de fin                                      ////
////     cl       - Couleur                                                 ////
void TFT_Ligne(unsigned x1, unsigned y1, unsigned x2, unsigned y2, unsigned cl)
{
   int  x, y, addx, addy, dx, dy;
   int  P;
   unsigned i;
   dx = abs((int)(x2 - x1));
   dy = abs((int)(y2 - y1));
   x = x1;
   y = y1;

   if(x1 > x2)
      addx = -1;
   else
      addx = 1;
   if(y1 > y2)
      addy = -1;
   else
      addy = 1;

   if(dx >= dy)
   {
      P = 2*dy - dx;

      for(i=0; i<=dx; ++i)
      {
         TFT_Dot(x, y, cl);

         if(P < 0)
         {
            P += 2*dy;
            x += addx;
         }
         else
         {
            P += 2*dy - 2*dx;
            x += addx;
            y += addy;
         }
      }
   }
   else
   {
      P = 2*dx - dy;

      for(i=0; i<=dy; ++i)
      {
         TFT_Dot(x, y, cl);

         if(P < 0)
         {
            P += 2*dx;
            y += addy;
         }
         else
         {
            P += 2*dx - 2*dy;
            x += addx;
            y += addy;
         }
      }
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////     Trace un polygone                                                  ////
////                                                                        ////
////     numPoints  - Nombre de sommets du polygone                         ////
////     polyPoints - Tableau contenant les coordonnes des sommets         ////
////     cl_e       - Couleur                                               ////
void TFT_Poly(unsigned numPoints, pix_coord *polyPoints, unsigned cl_e)
{
    unsigned   counter;
    unsigned   sx, sy, ex, ey;

    TFT_Set_Pen(cl_e, 1);
    sx = polyPoints->x;
    sy = polyPoints->y;
    polyPoints++;
    for(counter = 0; counter < numPoints - 1; counter++)
    {
        ex = polyPoints->x;
        ey = polyPoints->y;
        TFT_Line(sx, sy, ex, ey);
        sx = ex;
        sy = ey;
        polyPoints++;
    }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////     Trace un polygone plein                                            ////
////                                                                        ////
////     numPoints  - Nombre de sommets du polygone                         ////
////     polyPoints - Tableau contenant les coordonnes des sommets         ////
////         cl_e - couleur tour                                            ////
////         cl_f - couleur fond                                            ////
void TFT_FillPoly(unsigned numPoints, pix_coord *polyPoints, unsigned int cl_e, unsigned int cl_f)
{
    unsigned   counter;
    unsigned   min_X, max_X, min_Y, max_Y;
    unsigned   nodes, polyX[20], polyY[20], pixelY, i, j, swap;
    float      nodeX[20];

    min_Y = 0;
    max_Y = 0;
    min_X = 0;
    max_X = 0;
    for (counter = 0; counter < numPoints; counter ++)
    {
        polyX[counter] = (polyPoints+counter)->x;
        polyY[counter] = (polyPoints+counter)->y;
        if ( polyX[counter] > max_X) max_X =  polyX[counter];
        if ( polyX[counter] < min_X) min_X =  polyX[counter];
        if ( polyY[counter] > max_Y) max_Y =  polyY[counter];
        if ( polyY[counter] < min_Y) min_Y =  polyY[counter];
    }
//----------------------------------------------------------------------------//
    for (pixelY = min_Y; pixelY < max_Y; pixelY++)
    {
        nodes = 0;
        j = numPoints - 1;
        for (i = 0; i < numPoints; i++)
        {
            if (((polyY[i] < pixelY) && (polyY[j] >= pixelY)) || ((polyY[j] < pixelY) && (polyY[i] >= pixelY)))
            {
                nodeX[nodes++] = ((float)polyX[i] + ((((float)pixelY - (float)polyY[i]) / (float)(polyY[j] - (float)polyY[i])) * ((float)polyX[j] - (float)polyX[i])));
            }
            j=i;
         }
         if (nodes != 0)
         {
           while (i<nodes-1)
           {
               if (nodeX[i] > nodeX[i+1])
               {
                   swap       = nodeX[i];
                   nodeX[i]   = nodeX[i+1];
                   nodeX[i+1] = swap;
                   i--;
               }
               else
               {
                   i++;
               }
            }
            TFT_Set_Pen(cl_f, 1);
            for (i=0; i<nodes; i+=2)
            {
                if (nodeX[i  ] >  max_X) break;
                if (nodeX[i+1] >  min_X)
                {
                    if (nodeX[i  ] <  min_X) nodeX[i  ] = min_X ;
                    if (nodeX[i+1] >  max_X) nodeX[i+1] = max_X;
                    TFT_Line((unsigned)ceil(nodeX[i]),pixelY,(unsigned)floor(nodeX[i+1]),pixelY);
                }
            }
        }
  }
  TFT_Set_Pen(cl_e, 1);
  for(counter = 0; counter < numPoints ; counter++)
  {
        TFT_Line(polyX[counter],polyY[counter],polyX[counter+1],polyY[counter+1]);
  }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////        Trace un cercle                                                 ////
////        (x,y) - centre                                                  ////
////         r    - rayon                                                   ////
////         f    - cercle/disque                                           ////
////         cl_e - couleur tour                                            ////
////         cl_f - couleur fond                                            ////
void TFT_Cercle(unsigned x, unsigned y, unsigned r, char f, unsigned int cl_e, unsigned int cl_f)
{
   int a;
   int b;
   int P;

   a = 0;
   b = r;
   P = 1 - r;

   do
   {
      if(f == 1)
      {
         TFT_Ligne(x-a+1, y+b-1, x+a-1, y+b-1, cl_f);
         TFT_Ligne(x-a+1, y-b+1, x+a-1, y-b+1, cl_f);
         TFT_Ligne(x-b+1, y+a-1, x+b-1, y+a-1, cl_f);
         TFT_Ligne(x-b+1, y-a+1, x+b-1, y-a+1, cl_f);
      }
      TFT_Dot(a+x, b+y, cl_e);
      TFT_Dot(b+x, a+y, cl_e);
      TFT_Dot(x-a, b+y, cl_e);
      TFT_Dot(x-b, a+y, cl_e);
      TFT_Dot(b+x, y-a, cl_e);
      TFT_Dot(a+x, y-b, cl_e);
      TFT_Dot(x-a, y-b, cl_e);
      TFT_Dot(x-b, y-a, cl_e);

      if(P < 0)
         P += 3 + 2 * a++;
      else
         P += 5 + 2 * (a++ - b--);
    } while(a <= b);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////        Trace un rectangle                                              ////
////                                                                        ////
////      (x1, y1) - coordonnes de dpart                                  ////
////      (x2, y2) - coordonnes de fin                                     ////
////         f     - plein / vide                                           ////
////         cl_e  - couleur tour                                           ////
////         cl_f  - couleur fond                                           ////
void TFT_Rect(unsigned x1, unsigned y1, unsigned x2, unsigned y2, char f, unsigned int cl_e, unsigned int cl_f)
{
   unsigned y;
   unsigned  ymax;
   if(f == 1)
   {
      if (y1 < y2)
      {
         y    = y1;
         ymax = y2;
      }
      else
      {
         y    = y2;
         ymax = y1;
      }

      for(; y < ymax; ++y)
         TFT_Ligne(x1+1, y, x2-1, y, cl_f);
   }
   TFT_Ligne(x1, y1, x2, y1, cl_e);
   TFT_Ligne(x1, y2, x2, y2, cl_e);
   TFT_Ligne(x1, y1, x1, y2, cl_e);
   TFT_Ligne(x2, y1, x2, y2, cl_e);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche un pixel 3x3 de la matrice                 ////
void  aff_pix_mat(pix_mat *pix)
{
    TFT_Dot( pix->x   , pix->y   ,pix->c_t);
    TFT_Dot((pix->x)+1, pix->y   ,pix->c_t);
    TFT_Dot((pix->x)+2, pix->y   ,pix->c_t);
    TFT_Dot( pix->x   ,(pix->y)+1,pix->c_t);
    TFT_Dot((pix->x)+1,(pix->y)+1,pix->c_c);
    TFT_Dot((pix->x)+2,(pix->y)+1,pix->c_t);
    TFT_Dot( pix->x   ,(pix->y)+2,pix->c_t);
    TFT_Dot((pix->x)+1,(pix->y)+2,pix->c_t);
    TFT_Dot((pix->x)+2,(pix->y)+2,pix->c_t);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche un pixel 2x2 de la matrice                 ////
void  aff_pix_2x2_mat(pix_mat *pix)
{
    TFT_Dot( pix->x   , pix->y   ,pix->c_c);
    TFT_Dot((pix->x)+1, pix->y   ,pix->c_c);
    TFT_Dot( pix->x   ,(pix->y)+1,pix->c_c);
    TFT_Dot((pix->x)+1,(pix->y)+1,pix->c_c);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche un pixel 1x1 de la matrice                 ////
void  aff_pix_1x1_mat(pix_mat *pix)
{
    TFT_Dot( pix->x   , pix->y   ,pix->c_c);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche un pixel 4x2x2 de la matrice               ////
void  aff_pix_4x2x2_mat(pix_mat *pix)
{
    TFT_Dot( pix->x   , pix->y   ,pix->c_c);
    TFT_Dot((pix->x)+1, pix->y   ,pix->c_c);
    TFT_Dot( pix->x   ,(pix->y)+1,pix->c_c);
    TFT_Dot((pix->x)+1,(pix->y)+1,pix->c_c);
    
    TFT_Dot((pix->x)+3, pix->y   ,pix->c_c);
    TFT_Dot((pix->x)+4, pix->y   ,pix->c_c);
    TFT_Dot((pix->x)+3,(pix->y)+1,pix->c_c);
    TFT_Dot((pix->x)+4,(pix->y)+1,pix->c_c);

    TFT_Dot( pix->x   ,(pix->y)+3,pix->c_c);
    TFT_Dot((pix->x)+1,(pix->y)+3,pix->c_c);
    TFT_Dot( pix->x   ,(pix->y)+4,pix->c_c);
    TFT_Dot((pix->x)+1,(pix->y)+4,pix->c_c);

    TFT_Dot((pix->x)+3,(pix->y)+3,pix->c_c);
    TFT_Dot((pix->x)+4,(pix->y)+3,pix->c_c);
    TFT_Dot((pix->x)+3,(pix->y)+4,pix->c_c);
    TFT_Dot((pix->x)+4,(pix->y)+4,pix->c_c);

}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche un pixel 3x3 de la matrice                 ////
void  aff_pix_4x3x3_mat(pix_mat *pix)
{
    int x;
    int y;
    
    x = pix->x;
    y = pix->y;
    
    TFT_Dot( x   , y   ,pix->c_t);
    TFT_Dot((x)+1, y   ,pix->c_t);
    TFT_Dot((x)+2, y   ,pix->c_t);
    TFT_Dot( x   ,(y)+1,pix->c_t);
    TFT_Dot((x)+1,(y)+1,pix->c_c);
    TFT_Dot((x)+2,(y)+1,pix->c_t);
    TFT_Dot( x   ,(y)+2,pix->c_t);
    TFT_Dot((x)+1,(y)+2,pix->c_t);
    TFT_Dot((x)+2,(y)+2,pix->c_t);
    
    x += 4;
    y += 4;
    
    TFT_Dot( x   , y   ,pix->c_t);
    TFT_Dot((x)+1, y   ,pix->c_t);
    TFT_Dot((x)+2, y   ,pix->c_t);
    TFT_Dot( x   ,(y)+1,pix->c_t);
    TFT_Dot((x)+1,(y)+1,pix->c_c);
    TFT_Dot((x)+2,(y)+1,pix->c_t);
    TFT_Dot( x   ,(y)+2,pix->c_t);
    TFT_Dot((x)+1,(y)+2,pix->c_t);
    TFT_Dot((x)+2,(y)+2,pix->c_t);

    x -= 4;
    
    TFT_Dot( x   , y   ,pix->c_t);
    TFT_Dot((x)+1, y   ,pix->c_t);
    TFT_Dot((x)+2, y   ,pix->c_t);
    TFT_Dot( x   ,(y)+1,pix->c_t);
    TFT_Dot((x)+1,(y)+1,pix->c_c);
    TFT_Dot((x)+2,(y)+1,pix->c_t);
    TFT_Dot( x   ,(y)+2,pix->c_t);
    TFT_Dot((x)+1,(y)+2,pix->c_t);
    TFT_Dot((x)+2,(y)+2,pix->c_t);
 
    x += 4;
    y -= 4;

    TFT_Dot( x   , y   ,pix->c_t);
    TFT_Dot((x)+1, y   ,pix->c_t);
    TFT_Dot((x)+2, y   ,pix->c_t);
    TFT_Dot( x   ,(y)+1,pix->c_t);
    TFT_Dot((x)+1,(y)+1,pix->c_c);
    TFT_Dot((x)+2,(y)+1,pix->c_t);
    TFT_Dot( x   ,(y)+2,pix->c_t);
    TFT_Dot((x)+1,(y)+2,pix->c_t);
    TFT_Dot((x)+2,(y)+2,pix->c_t);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Gnre un array des pixels du texte                ////
int  tab_string(char *chaine,char *tab_chaine)
{
   char       j;
   char       *offset;
   int        taille;

   taille = 0;
   for(;*chaine != '\0';++chaine)
   {
      if (iscntrl(*chaine)) *chaine = ' ';
      offset = &Font_5x7 + ((char)*chaine - ' ')*5;
      for (j=0; j<5; j++)
      {
         *(tab_chaine++)= *(offset++);
         taille++;
      }
      *(tab_chaine++) = 0;
      taille++;
   }
   return (taille - 1);
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////           Affiche un tableau de pixel en matrice (pixel 2x2)           ////
void  aff_tab_mat_2x2(chaine_mat *tab_chaine)
{
   unsigned    j;
   char        k;
   unsigned    x;
   char       *offset;
   char        pix_data;
   pix_mat     pix;
   unsigned    zone;

   x = 0;
   offset = tab_chaine->bit_chaine;
   if (tab_chaine->taille > tab_chaine->largeur) zone = tab_chaine->largeur;
   else zone = tab_chaine->taille;
   
   for (j=0; j < zone; j++)
   {
      pix_data = *(offset + tab_chaine->delta++);
      if (tab_chaine->delta == tab_chaine->taille) tab_chaine->delta = 0;
      for (k=0; k < 7; k++)
      {
         pix.x = tab_chaine->x +(x*3);
         pix.y = tab_chaine->y +(k*3);
         if (BIT_TEST(pix_data, k) != 0)
         {
            pix.c_c = tab_chaine->c_c;
         }
         else
         {
            pix.c_c = tab_chaine->f_c;
         }
         aff_pix_2x2_mat(&pix);
      }
      x++;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche une matrice de chiffre (pixel 3x3)         ////
void  aff_carac_mat(car_mat *car)
{
   char j;
   char k;
   char x;
   char       *offset;
   char        pix_data;
   pix_mat     pix;
   x = 0;
   offset = &Font_5x7 + (car->carac - ' ')*5;
   for (j=0; j<5; j++)
   {
      pix_data = *(offset++);
      for (k=0; k < 7; k++)
      {
         pix.x = car->x +(x*4);
         pix.y = car->y +(k*4);
         if (BIT_TEST(pix_data, k) != 0)
         {
            pix.c_t = car->c_t;
            pix.c_c = car->c_c;
         }
         else
         {
            pix.c_t = car->f_t;
            pix.c_c = car->f_c;
         }
         aff_pix_mat(&pix);
      }
      x++;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche un  caractre  partir de la police        ////
void aff_car(car_mat *car,int y_d, int y_h)
{
    char           *offset;
    char           *offset_car;
    char           *data_car;

    char           firstcar;          // Character code of first character (e.g. 32).
    char           lastcar;           // Character code of last character in font (e.g. 3006).
    pix_mat        pix;
    unsigned short height;             // Font characters height in pixels.
    unsigned short width;              // largeur du car
    unsigned short offsetLSB;          // Least Significant unsigned short of the glyph location offset
    unsigned       offsetMSB;          // Most Significant (2) unsigned shorts of the glyph location offset

    int            xCnt, yCnt;
    char           temp , mask;
    unsigned       tempo;

    offset     = &Rockwell_Extra_Bold_18;
    firstcar   = *(offset + 2);
    lastcar    = *(offset + 4);
    height     = *(offset + 6);

    tempo      = (unsigned)(car->carac - ' ') ;
    tempo     *= 4;
    tempo     += 8;
    offset_car = offset + tempo;

    width       = *(offset_car);
    offsetLSB   = *(offset_car + 1);
    offsetMSB   = (*(offset_car + 3) << 8) + (*(offset_car + 2));
    data_car    = offset + ((unsigned)offsetMSB << 8) + offsetLSB;

    for(yCnt = 0; yCnt < (int)height; yCnt++)
    {
       mask = 0;
       for(xCnt = 0; xCnt < (int)width; xCnt++)
       {
          pix.x = car->x +(xCnt*2);
          pix.y = car->y +((yCnt - y_d)*2);
          if(mask == 0)
          {
             temp = *(data_car++);
             mask = 0x01;
          }
          if(temp & mask)
          {
             pix.c_t = car->c_t;
             pix.c_c = car->c_c;
          }
          else
          {
             pix.c_t = car->f_t;
             pix.c_c = car->f_c;
          }
          if ((yCnt > y_d) && (yCnt < y_h))
          {
             aff_pix_2x2_mat(&pix);
          }
          mask <<= 1;
       }
    }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////                     Affiche une matrice de chiffre (pixel 3x3)         ////
////           Police de caractre h 16 Rockwell                            ////
void  aff_carac_mat_rockwell(car_mat *car,int y_d, int y_h)
{
    char           *offset;
    char           *offset_car;
    char           *data_car;

    char           firstcar;          // Character code of first character (e.g. 32).
    char           lastcar;           // Character code of last character in font (e.g. 3006).
    pix_mat        pix;
    unsigned short height;             // Font characters height in pixels.
    unsigned short width;              // largeur du car
    unsigned short offsetLSB;          // Least Significant unsigned short of the glyph location offset
    unsigned       offsetMSB;          // Most Significant (2) unsigned shorts of the glyph location offset

    int            xCnt, yCnt;
    char           temp , mask;
    unsigned       tempo;

    offset     = &Rockwell_Extra_Bold_18;
    firstcar   = *(offset + 2);
    lastcar    = *(offset + 4);
    height     = *(offset + 6);

    tempo      = (unsigned)(car->carac - ' ') ;
    tempo     *= 4;
    tempo     += 8;
    offset_car = offset + tempo;

    width       = *(offset_car);
    offsetLSB   = *(offset_car + 1);
    offsetMSB   = (*(offset_car + 3) << 8) + (*(offset_car + 2));
    data_car    = offset + ((unsigned)offsetMSB << 8) + offsetLSB;

    for(yCnt = 0; yCnt < (int)height; yCnt++)
    {
       mask = 0;
       for(xCnt = 0; xCnt < (int)width; xCnt++)
       {
          pix.x = car->x +(xCnt*4);
          pix.y = car->y +((yCnt - y_d)*4);
          if(mask == 0)
          {
             temp = *(data_car++);
             mask = 0x01;
          }
          if(temp & mask)
          {
             //TFT_Dot(x, y,CL_WHITE);
             pix.c_t = car->c_t;
             pix.c_c = car->c_c;
          }
          else
          {
             pix.c_t = car->f_t;
             pix.c_c = car->f_c;
          }
          if ((yCnt > y_d) && (yCnt < y_h))
          {
             aff_pix_mat(&pix);
          }
          mask <<= 1;
       }
    }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////           Affiche une matrice de chiffre (pixel 4x2x2)                 ////
void  aff_carac_mat_2x2(car_mat *car)
{
   char j;
   char k;
   char x;
   char       *offset;
   char        pix_data;
   pix_mat     pix;
   x = 0;
   offset = &Font_5x7 + (car->carac - ' ')*5;
   for (j=0; j<5; j++)
   {
      pix_data = *(offset++);
      for (k=0; k < 7; k++)
      {
         pix.x = car->x +(x*3);
         pix.y = car->y +(k*3);
         if (BIT_TEST(pix_data, k) != 0)
         {
            pix.c_t = car->c_t;
            pix.c_c = car->c_c;
         }
         else
         {
            pix.c_t = car->f_t;
            pix.c_c = car->f_c;
         }
         aff_pix_2x2_mat(&pix);
      }
      x++;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////           Affiche une matrice de chiffre (pixel 4x3x3)                 ////
void  aff_carac_mat_4x3x3(car_mat *car)
{
   char j;
   char k;
   char x;
   char       *offset;
   char        pix_data;
   pix_mat     pix;
   x = 0;
   offset = &Font_5x7 + (car->carac - ' ')*5;
   for (j=0; j<5; j++)
   {
      pix_data = *(offset++);
      for (k=0; k < 7; k++)
      {
         pix.x = car->x +(x*8);
         pix.y = car->y +(k*8);
         if (BIT_TEST(pix_data, k) != 0)
         {
            pix.c_t = car->c_t;
            pix.c_c = car->c_c;
         }
         else
         {
            pix.c_t = car->f_t;
            pix.c_c = car->f_c;
         }
         aff_pix_4x3x3_mat(&pix);
      }
      x++;
   }
}
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////           Affiche une matrice de chiffre (pixel 4x2x2)                 ////
void  aff_carac_mat_4x2x2(car_mat *car)
{
   char j;
   char k;
   char x;
   char       *offset;
   char        pix_data;
   pix_mat     pix;
   x = 0;
   offset = &Font_5x7 + (car->carac - ' ')*5;
   for (j=0; j<5; j++)
   {
      pix_data = *(offset++);
      for (k=0; k < 7; k++)
      {
         pix.x = car->x +(x*6);
         pix.y = car->y +(k*6);
         if (BIT_TEST(pix_data, k) != 0)
         {
            pix.c_t = car->c_t;
            pix.c_c = car->c_c;
         }
         else
         {
            pix.c_t = car->f_t;
            pix.c_c = car->f_c;
         }
         aff_pix_4x2x2_mat(&pix);
      }
      x++;
   }
}