////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////              Dclaration des variables Globales                        ////
#define                ON            1
#define                OFF           0
#define                FALSE         0
#define                TRUE          1
#define                NULL          0

#define                MAXX  240
#define                MAXY  320
#define                COUL_FOND      0x10A2

#define                BIT_TEST(x,n) (x & (0x01<<n))
#define                SET_BIT(x,n) (x | (0x01<<n))

/*------------------ EEPROM SECTEUR 0 ----------------------------------------*/
#define                SEC_0        0x00

#define                AD_FUSEAU    0x00
#define                AD_ETE       0x01
#define                AD_H_AUTO    0x02
#define                AD_JEU_MEM   0x03
#define                AD_MEM_ACT   0x04
#define                AD_VOLUME    0x05

/*------------------ EEPROM SECTEUR 1 ----------------------------------------*/
#define                SEC_1        0x1000

#define                AD_FREQUENCE 0x00

#define                AD_MEM_0     0x10
#define                AD_MEM_1     0x11
#define                AD_MEM_2     0x12
#define                AD_MEM_3     0x13
#define                AD_MEM_4     0x14
#define                AD_MEM_5     0x15
#define                AD_MEM_6     0x16
#define                AD_MEM_7     0x17
/*------------------ EEPROM SECTEUR 2 ----------------------------------------*/
#define                SEC_2        0x2000

#define                AD_NOM_OK    0x00

#define                AD_NOM_1     0x10
#define                AD_NOM_2     0x20
#define                AD_NOM_3     0x30
#define                AD_NOM_4     0x40
#define                AD_NOM_5     0x50
#define                AD_NOM_6     0x60
#define                AD_NOM_7     0x70
#define                AD_NOM_8     0x80

/*----------------------------------------------------------------------------*/
#define                T_EEPROM     0x20
#define                T_NOM        0x90

static char            tempo_500;
static char            tempo_sec;
static short           flag_pwr;
static short           flag_sec;
static unsigned short  volume;
static unsigned        frequence;
static short           puissance;
static short           sensibilite;
static int             scroll;
static int             max_scroll;
static short           flag_frequence;
static short           flag_mute;
static short           flag_bascule;
static short           flag_stereo;
static short           flag_rds;
static short           flag_logo_rds;
static unsigned short  eprom_0[T_EEPROM];
static unsigned        eprom_1[T_EEPROM];
static unsigned short  eprom_2[T_NOM];

////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////              Dclaration des structures globales                       ////
typedef char ch_txt_17[17];
typedef char ch_txt_2[2];
typedef char ch_txt_3[3];
typedef char ch_txt_4[4];
typedef char ch_txt_10[11];
typedef struct
{
   unsigned short valide;
   unsigned short erreur_1;
   unsigned short erreur_2;
   unsigned       groupe_A;
   unsigned       groupe_B;
   unsigned       groupe_C;
   unsigned       groupe_D;
   unsigned short type_groupe;
   unsigned       pi;
   unsigned short pty;
   unsigned short num_ps_trame;
   unsigned short cnt_ps_trame;
   unsigned short ps_ok;
   char           ps[9];
   unsigned short flag_rt_trame;
   unsigned short num_rt_trame;
   unsigned       cnt_rt_trame;
   unsigned short rt_ok;
   char           rt[65];
   unsigned long  date;
   unsigned short hh;
   unsigned short mm;
   unsigned short ss;
   unsigned short jj;
   unsigned short dd;
   unsigned short mo;
   unsigned short yy;
   short          fuseau;
   char           heure_ok;
   
   
} rds;
typedef struct
{
         char   change;
         short  fuseau;
         short  ete_hiver;
         short  hh;
         short  mm;
         short  ss;
         short  jj;
         short  dd;
         short  mo;
         short  yy;
} heudat;
typedef struct
{
         unsigned  x;
         unsigned  y;
         unsigned  c_t;
         unsigned  c_c;
} pix_mat;
typedef struct
{
         unsigned  x;
         unsigned  y;
         char      carac;
         unsigned  c_t;
         unsigned  c_c;
         unsigned  f_t;
         unsigned  f_c;
} car_mat;
typedef struct
{
         unsigned x;
         unsigned y;
} pix_coord;
typedef struct
{
         unsigned  x;
         unsigned  y;
         unsigned  largeur;
         char      bit_chaine[385];
         int       taille;
         unsigned  delta;
         unsigned  c_t;
         unsigned  c_c;
         unsigned  f_t;
         unsigned  f_c;
} chaine_mat;
typedef struct
{
         unsigned short etat;
         unsigned       freq;
         char           nom[9];
         unsigned short nom_ok;
         unsigned long *img_on;
         unsigned long *img_off;
         unsigned       x;
         unsigned       y;
} memoire;
         
unsigned long *digit_heure[12];


/////                                                                        ////
////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////              Dclaration des variables graphiques                      ////
////                                                                        ////

////                                                                        ////
////////////////////////////////////////////////////////////////////////////////
////       Prcurseur fonction                                              ////
void SPI_Device_CS_Enable_Disable(char Device_Name);
void aff_tuner_off();
void aff_tuner_on();
void aff_setup();
void aff_setup_heure();
void aff_setup_date();
void aff_menu_setup(memoire *btn);
void menu_setup(memoire *btn,heudat *hpic, ch_txt_17 *jour,ch_txt_17 *mois, short *heure_auto);
void menu_memoire(memoire *mem);
void menu_stereo(memoire *mem);
void menu_sensibilite(memoire *mem);
void menu_heure(memoire *mem, heudat *hpic, ch_txt_17 *jour,ch_txt_17 *mois, short *heure_auto);
void menu_reglage_heure(memoire *mem, heudat *hpic, ch_txt_17 *jour,ch_txt_17 *mois);
void aff_date_ecran_off(int x, int y,heudat *heur,ch_txt_17 *jour,ch_txt_17 *mois);
void aff_heure_ecran_off(int x,int y,heudat *hpic,short top_s);
void aff_heure_ecran_on(int x_c,int y,heudat *hpic,short top_s);
void aff_heure_ecran_reglage(int x, int y,heudat *heur,short top_s);
void aff_date_ecran_reglage(int x, int y,heudat *heur, ch_txt_17 *jour, ch_txt_17 *mois);
void aff_frequence(int x, int y, unsigned freq);
void aff_nom(int x, int y, rds *trame);
void aff_texte(int x, int y, int delta, rds *trame);
void aff_icone(int x,int y);
void aff_mem(char jeu, memoire *btn);
void test_mem(char *jeu, memoire *btn, unsigned freq);
void aff_mem_text(short i, memoire *btn,char *carac);
void aff_mire_fond_ecran_off(int x, int y);
void aff_mire_fond_ecran_on(int x, int y);
void aff_fond_ecran_on(int x, int y);
void jour_sem(heudat *heur);
short bissextile(heudat *heur);
void heure_ete_hiver(heudat *heur);
void aff_date(char y_d,heudat *heur,ch_txt_17 *jour,ch_txt_17 *mois);
void date_heure(heudat *heur, char *d_j);
short heure_pic(heudat *hpic);
void heure_rds(rds *trame, heudat *hrds);
char gestion_heure(heudat *hpic, heudat *hrds);