///////////////////////////////////////////////////////////////////////////////
////                                                                       ////
////  * Gestion de l'horloge temps rel intgre au PIC32                  ////
////                                                                       ////
///////////////////////////////////////////////////////////////////////////////
////                                                                       ////
////                                                                       ////
///////////////////////////////////////////////////////////////////////////////
////                                                                       ////

void Init_RTCC(void) // Initialisation du module RTCC
{
  // RTCC registers unlock procedure
  SYSKEY = 0;
  SYSKEY = 0xAA996655;      // Write first unlock key to SYSKEY
  SYSKEY = 0x556699AA;      // Write second unlock key to SYSKEY

  OSCCONSET = 2;
  RTCWREN_bit = 1;          // RTC Value registers can be written to by the user
  RTSECSEL_bit = 1;         // RTCC Seconds Clock is selected for the RTCC pin

  ON__RTCCON_bit= 1;        // Turn on the RTCC module
  SYSKEY = 0;
  while(!(SOSCRDY));
  while(!(RTCCON&0x40));     // Wait for clock to be turned on
}
void Write_RTCC_HHMMSS(char hh, char mm, char ss) // Mise  l'heure du module RTCC
{
   unsigned long hhmmss;

   hhmmss  = Dec2Bcd16(hh);
   hhmmss *= 256;
   hhmmss += Dec2Bcd16(mm);
   hhmmss *= 256;
   hhmmss += Dec2Bcd16(ss);
   hhmmss *= 256;
   // RTCC registers unlock procedure
   SYSKEY = 0;
   SYSKEY = 0xAA996655;      // Write first unlock key to SYSKEY
   SYSKEY = 0x556699AA;      // Write second unlock key to SYSKEY

   RTCWREN_bit = 1;          // RTC Value registers can be written to by the user
   RTCCONCLR=0x8000; // turn off the RTCC
   while(RTCCON&0x40); // wait for clock to be turned off
   RTCTIME=hhmmss; // safe to update the time
   RTCCONSET=0x8000; // turn on the RTCC
   SYSKEY = 0;
   while(!(RTCCON&0x40));
}
void Write_RTCC_YYMMDDJS(char js, char dd, char mm, char yy) // Mise  la date du module RTCC
{
   unsigned long yymmddjs;

   yymmddjs  = Dec2Bcd16(yy);
   yymmddjs *= 256;
   yymmddjs += Dec2Bcd16(mm);
   yymmddjs *= 256;
   yymmddjs += Dec2Bcd16(dd);
   yymmddjs *= 256;
   yymmddjs += Dec2Bcd16(js);
   // RTCC registers unlock procedure
   SYSKEY = 0;
   SYSKEY = 0xAA996655;      // Write first unlock key to SYSKEY
   SYSKEY = 0x556699AA;      // Write second unlock key to SYSKEY
   RTCWREN_bit = 1;          // RTC Value registers can be written to by the user
   RTCCONCLR=0x8000; // turn off the RTCC
   while(RTCCON&0x40); // wait for clock to be turned off
   RTCDATE=yymmddjs; // safe to update the date
   RTCCONSET=0x8000; // turn on the RTCC
   SYSKEY = 0;
   while(!(RTCCON&0x40));
}
unsigned long Read_Time(void)
{
   return RTCTIME;
}
unsigned long Read_Date(void)
{
   return RTCDATE;
}
unsigned short Read_Heure(unsigned long hhmmss)
{
   unsigned short hh;
   hh = bcd2dec(highest(hhmmss));
   return hh;
}
unsigned short Read_Minute(unsigned long hhmmss)
{
   unsigned short mm;
   mm = bcd2dec(higher(hhmmss));
   return mm;
}
unsigned short Read_Seconde(unsigned long hhmmss)
{
   unsigned short ss;
   ss = bcd2dec(hi(hhmmss));
   return ss;
}
unsigned short Read_Jour_Sem(unsigned long jsddmmyy)
{
   unsigned short js;
   js = bcd2dec(lo(jsddmmyy));
   return js;
}
unsigned short Read_Jour(unsigned long jsddmmyy)
{
   unsigned short dd;
   dd = bcd2dec(hi(jsddmmyy));
   return dd;
}
unsigned short Read_Mois(unsigned long jsddmmyy)
{
   unsigned short mm;
   mm = bcd2dec(higher(jsddmmyy));
   return mm;
}
unsigned short Read_Annee(unsigned long jsddmmyy)
{
   unsigned short yy;
   yy = bcd2dec(highest(jsddmmyy));
   return yy;
}